{
 	File:		ADB.p
 
 	Contains:	ADB Interface for System 8
 
 	Version:	Technology:	
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT ADB;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __ADB__}
{$SETC __ADB__ := 1}

{$I+}
{$SETC ADBIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}
{$IFC UNDEFINED __IOITERATOR__}
{$I IOIterator.p}
{$ENDC}

{$PUSH}
{$ALIGN POWER}
{$LibExport+}

{$IFC FOR_SYSTEM8_PREEMPTIVE }
{
------------------------------------------------------------------------------------
  Types
------------------------------------------------------------------------------------
}

CONST
	kADBCurrentIteratorDescVersion = 1;


TYPE
	ADBIOIteratorDataPtr = ^ADBIOIteratorData;
	ADBIOIteratorData = RECORD
		IOCI:					IOCommonInfo;							{  common data for all families	 }
		currentAddress:			SInt8;
		defaultAddress:			SInt8;
		defaultHandlerID:		SInt8;
	END;

	ADBConnectionID						= UInt32;
	ADBRegisterContentsPtr = ^ADBRegisterContents;
	ADBRegisterContents = RECORD
		data:					PACKED ARRAY [0..7] OF Byte;
		length:					ByteCount;
	END;

{
------------------------------------------------------------------------------------
  Calls
------------------------------------------------------------------------------------
}
FUNCTION ADBGetDeviceData(requestCount: ItemCount; VAR totalCount: ItemCount; VAR deviceData: ADBIOIteratorData): OSStatus; C;
FUNCTION ADBOpen({CONST}VAR ref: IODeviceRef; VAR connection: ADBConnectionID): OSStatus; C;
FUNCTION ADBClose(connection: ADBConnectionID): OSStatus; C;
FUNCTION ADBGetNextAutopoll(connection: ADBConnectionID; timeOut: Duration; VAR contents: ADBRegisterContents; VAR timestamp: AbsoluteTime): OSStatus; C;
{  ADBGetRegister sends a Talk command over the wire }
FUNCTION ADBGetRegister(connection: ADBConnectionID; registerNumber: ByteParameter; VAR contents: ADBRegisterContents; VAR timestamp: AbsoluteTime): OSStatus; C;
{
 ADBSetRegister sends a Listen command over the wire
 Note, only allowed for registers 0, 1, and 2
 Use the specific calls to set individual fields of register 3
}
FUNCTION ADBSetRegister(connection: ADBConnectionID; registerNumber: ByteParameter; {CONST}VAR contents: ADBRegisterContents): OSStatus; C;
FUNCTION ADBGetHandlerID(connection: ADBConnectionID; VAR handlerID: Byte): OSStatus; C;
FUNCTION ADBSetHandlerID(connection: ADBConnectionID; handlerID: ByteParameter): OSStatus; C;
{
 for ADBGetStatusBits and ADBSetStatusBits,
 the 4 most significant bits of the bits parameter
 contain the 4 most significant bits of the first byte of device register 3
}
FUNCTION ADBGetStatusBits(connection: ADBConnectionID; VAR bits: Byte): OSStatus; C;
FUNCTION ADBSetStatusBits(connection: ADBConnectionID; bits: ByteParameter): OSStatus; C;
{  see the Guide to Macintosh Family Hardware for more info on an ADB device activator }
FUNCTION ADBTestActivator(connection: ADBConnectionID; VAR activatorPressed: BOOLEAN): OSStatus; C;
FUNCTION ADBFlush(connection: ADBConnectionID): OSStatus; C;
FUNCTION ADBResetBus: OSStatus; C;
{
------------------------------------------------------------------------------------
  status codes
------------------------------------------------------------------------------------
}
{  ADB assigned range is -30279 to -30260 inclusive }

CONST
	adbDeviceBusyErr			= -30279;						{  device already Opened }
	adbInvalidConnectionIDErr	= -30278;
	adbConnectionTerminatedErr	= -30277;						{  device closed or unplugged during the call }
	adbDeviceTimeoutErr			= -30276;
	adbReservedHandlerIDErr		= -30275;
	adbInvalidHandlerIDErr		= -30274;

{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := ADBIncludes}

{$ENDC} {__ADB__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
