{
 	File:		CMApplication.p
 
 	Contains:	Color Matching Interfaces
 
 	Version:	Technology:	ColorSync 2.0
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT CMApplication;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __CMAPPLICATION__}
{$SETC __CMAPPLICATION__ := 1}

{$I+}
{$SETC CMApplicationIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}
{$IFC UNDEFINED __QUICKDRAW__}
{$I Quickdraw.p}
{$ENDC}
{$IFC UNDEFINED __FILES__}
{$I Files.p}
{$ENDC}
{$IFC UNDEFINED __PRINTING__}
{$I Printing.p}
{$ENDC}
{$IFC UNDEFINED __CMICCPROFILE__}
{$I CMICCProfile.p}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{$IFC FOR_SYSTEM7_AND_SYSTEM8_COOPERATIVE }

CONST
	kDefaultCMMSignature		= 'appl';

{  Macintosh 68K trap word  }
	cmTrap						= $ABEE;

{  PicComment IDs  }
	cmBeginProfile				= 220;
	cmEndProfile				= 221;
	cmEnableMatching			= 222;
	cmDisableMatching			= 223;
	cmComment					= 224;

{  PicComment selectors for cmComment  }
	cmBeginProfileSel			= 0;
	cmContinueProfileSel		= 1;
	cmEndProfileSel				= 2;

{  Defines for version 1.0 CMProfileSearchRecord.fieldMask  }
	cmMatchCMMType				= $00000001;
	cmMatchApplProfileVersion	= $00000002;
	cmMatchDataType				= $00000004;
	cmMatchDeviceType			= $00000008;
	cmMatchDeviceManufacturer	= $00000010;
	cmMatchDeviceModel			= $00000020;
	cmMatchDeviceAttributes		= $00000040;
	cmMatchFlags				= $00000080;
	cmMatchOptions				= $00000100;
	cmMatchWhite				= $00000200;
	cmMatchBlack				= $00000400;

{  Defines for version 2.0 CMSearchRecord.searchMask  }
	cmMatchAnyProfile			= $00000000;
	cmMatchProfileCMMType		= $00000001;
	cmMatchProfileClass			= $00000002;
	cmMatchDataColorSpace		= $00000004;
	cmMatchProfileConnectionSpace = $00000008;
	cmMatchManufacturer			= $00000010;
	cmMatchModel				= $00000020;
	cmMatchAttributes			= $00000040;
	cmMatchProfileFlags			= $00000080;

{  Result codes  }
																{  General Errors  }
	cmProfileError				= -170;
	cmMethodError				= -171;
	cmMethodNotFound			= -175;							{  CMM not present  }
	cmProfileNotFound			= -176;							{  Responder error  }
	cmProfilesIdentical			= -177;							{  Profiles the same  }
	cmCantConcatenateError		= -178;							{  Profile can't be concatenated  }
	cmCantXYZ					= -179;							{  CMM cant handle XYZ space  }
	cmCantDeleteProfile			= -180;							{  Responder error  }
	cmUnsupportedDataType		= -181;							{  Responder error  }
	cmNoCurrentProfile			= -182;							{  Responder error  }
																{  Profile Access Errors  }
	cmElementTagNotFound		= -4200;
	cmIndexRangeErr				= -4201;						{  Index out of range  }
	cmCantDeleteElement			= -4202;
	cmFatalProfileErr			= -4203;
	cmInvalidProfile			= -4204;						{  A Profile must contain a 'cs1 ' tag to be valid  }
	cmInvalidProfileLocation	= -4205;						{  Operation not supported for this profile location  }
																{  Profile Search Errors  }
	cmInvalidSearch				= -4206;						{  Bad Search Handle  }
	cmSearchError				= -4207;
	cmErrIncompatibleProfile	= -4208;						{  Other ColorSync Errors  }
	cmInvalidColorSpace			= -4209;						{  Profile colorspace does not match bitmap type  }
	cmInvalidSrcMap				= -4210;						{  Source pix/bit map was invalid  }
	cmInvalidDstMap				= -4211;						{  Destination pix/bit map was invalid  }
	cmNoGDevicesError			= -4212;						{  Begin/End Matching -- no gdevices available  }
	cmInvalidProfileComment		= -4213;						{  Bad Profile comment during drawpicture  }
																{  Color Conversion Errors  }
	cmRangeOverFlow				= -4214;						{  Warning that some output color values over/underflowed and were clipped  }
																{  Other Profile Access Errors  }
	cmCantCopyModifiedV1Profile	= -4215;						{  Illegal to copy version 1 profiles that have been modified  }
																{  NamedColor Errors  }
	cmNamedColorNotFound		= -4216;						{  namedColor not found  }

{  deviceType values for ColorSync 1.0 Device Profile access  }
	cmSystemDevice				= 'sys ';
	cmGDevice					= 'gdev';

{  Commands for CMFlattenUPP()  }
	cmOpenReadSpool				= 1;
	cmOpenWriteSpool			= 2;
	cmReadSpool					= 3;
	cmWriteSpool				= 4;
	cmCloseSpool				= 5;

{  Flags for PostScript-related functions  }
	cmPS7bit					= 1;
	cmPS8bit					= 2;

{  Abstract data type for memory-based Profile  }

TYPE
	CMProfileRef						= Ptr;
{  Abstract data type for Profile search result  }
	CMProfileSearchRef					= Ptr;
{  Abstract data type for BeginMatching() reference  }
	CMMatchRef							= Ptr;
{  Abstract data type for ColorWorld reference  }
	CMWorldRef							= Ptr;
{  Caller-supplied flatten function  }
	CMFlattenProcPtr = ProcPtr;  { FUNCTION CMFlatten(command: LONGINT; VAR size: LONGINT; data: UNIV Ptr; refCon: UNIV Ptr): OSErr; }

{  Caller-supplied progress function for Bitmap & PixMap matching routines  }
	CMBitmapCallBackProcPtr = ProcPtr;  { FUNCTION CMBitmapCallBack(progress: LONGINT; refCon: UNIV Ptr): BOOLEAN; }

{  Caller-supplied filter function for Profile search  }
	CMProfileFilterProcPtr = ProcPtr;  { FUNCTION CMProfileFilter(prof: CMProfileRef; refCon: UNIV Ptr): BOOLEAN; }

	CMFlattenUPP = UniversalProcPtr;
	CMBitmapCallBackUPP = UniversalProcPtr;
	CMProfileFilterUPP = UniversalProcPtr;

CONST
	uppCMFlattenProcInfo = $00003FE0;
	uppCMBitmapCallBackProcInfo = $000003D0;
	uppCMProfileFilterProcInfo = $000003D0;

FUNCTION NewCMFlattenProc(userRoutine: CMFlattenProcPtr): CMFlattenUPP;
	{$IFC NOT GENERATINGCFM }
	INLINE $2E9F;
	{$ENDC}

FUNCTION NewCMBitmapCallBackProc(userRoutine: CMBitmapCallBackProcPtr): CMBitmapCallBackUPP;
	{$IFC NOT GENERATINGCFM }
	INLINE $2E9F;
	{$ENDC}

FUNCTION NewCMProfileFilterProc(userRoutine: CMProfileFilterProcPtr): CMProfileFilterUPP;
	{$IFC NOT GENERATINGCFM }
	INLINE $2E9F;
	{$ENDC}

FUNCTION CallCMFlattenProc(command: LONGINT; VAR size: LONGINT; data: UNIV Ptr; refCon: UNIV Ptr; userRoutine: CMFlattenUPP): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $205F, $4E90;
	{$ENDC}

FUNCTION CallCMBitmapCallBackProc(progress: LONGINT; refCon: UNIV Ptr; userRoutine: CMBitmapCallBackUPP): BOOLEAN;
	{$IFC NOT GENERATINGCFM}
	INLINE $205F, $4E90;
	{$ENDC}

FUNCTION CallCMProfileFilterProc(prof: CMProfileRef; refCon: UNIV Ptr; userRoutine: CMProfileFilterUPP): BOOLEAN;
	{$IFC NOT GENERATINGCFM}
	INLINE $205F, $4E90;
	{$ENDC}

TYPE
	CMError								= LONGINT;
{  For 1.0 and 2.0 profile header variants  }
{  CMAppleProfileHeader  }
	CMAppleProfileHeaderPtr = ^CMAppleProfileHeader;
	CMAppleProfileHeader = RECORD
		CASE INTEGER OF
		0: (
			cm1:				CMHeader;
			);
		1: (
			cm2:				CM2Header;
			);
	END;

{  Param for CWConcatColorWorld()  }
	CMConcatProfileSetPtr = ^CMConcatProfileSet;
	CMConcatProfileSet = RECORD
		keyIndex:				INTEGER;								{  Zero-based  }
		count:					INTEGER;								{  Min 1  }
		profileSet:				ARRAY [0..0] OF CMProfileRef;			{  Variable. Ordered from Source -> Dest  }
	END;

{  ColorSync color data types  }
	CMRGBColorPtr = ^CMRGBColor;
	CMRGBColor = RECORD
		red:					INTEGER;								{  0..65535  }
		green:					INTEGER;
		blue:					INTEGER;
	END;

	CMCMYKColorPtr = ^CMCMYKColor;
	CMCMYKColor = RECORD
		cyan:					INTEGER;								{  0..65535  }
		magenta:				INTEGER;
		yellow:					INTEGER;
		black:					INTEGER;
	END;

	CMCMYColorPtr = ^CMCMYColor;
	CMCMYColor = RECORD
		cyan:					INTEGER;								{  0..65535  }
		magenta:				INTEGER;
		yellow:					INTEGER;
	END;

	CMHLSColorPtr = ^CMHLSColor;
	CMHLSColor = RECORD
		hue:					INTEGER;								{  0..65535. Fraction of circle. Red at 0  }
		lightness:				INTEGER;								{  0..65535  }
		saturation:				INTEGER;								{  0..65535  }
	END;

	CMHSVColorPtr = ^CMHSVColor;
	CMHSVColor = RECORD
		hue:					INTEGER;								{  0..65535. Fraction of circle. Red at 0  }
		saturation:				INTEGER;								{  0..65535  }
		value:					INTEGER;								{  0..65535  }
	END;

	CMLabColorPtr = ^CMLabColor;
	CMLabColor = RECORD
		L:						INTEGER;								{  0..65535 maps to 0..100  }
		a:						INTEGER;								{  0..65535 maps to -128..127.996  }
		b:						INTEGER;								{  0..65535 maps to -128..127.996  }
	END;

	CMLuvColorPtr = ^CMLuvColor;
	CMLuvColor = RECORD
		L:						INTEGER;								{  0..65535 maps to 0..100  }
		u:						INTEGER;								{  0..65535 maps to -128..127.996  }
		v:						INTEGER;								{  0..65535 maps to -128..127.996  }
	END;

	CMYxyColorPtr = ^CMYxyColor;
	CMYxyColor = RECORD
		capY:					INTEGER;								{  0..65535 maps to 0..1  }
		x:						INTEGER;								{  0..65535 maps to 0..1  }
		y:						INTEGER;								{  0..65535 maps to 0..1  }
	END;

	CMGrayColorPtr = ^CMGrayColor;
	CMGrayColor = RECORD
		gray:					INTEGER;								{  0..65535  }
	END;

	CMMultichannel5ColorPtr = ^CMMultichannel5Color;
	CMMultichannel5Color = RECORD
		components:				PACKED ARRAY [0..4] OF UInt8;			{  0..255  }
	END;

	CMMultichannel6ColorPtr = ^CMMultichannel6Color;
	CMMultichannel6Color = RECORD
		components:				PACKED ARRAY [0..5] OF UInt8;			{  0..255  }
	END;

	CMMultichannel7ColorPtr = ^CMMultichannel7Color;
	CMMultichannel7Color = RECORD
		components:				PACKED ARRAY [0..6] OF UInt8;			{  0..255  }
	END;

	CMMultichannel8ColorPtr = ^CMMultichannel8Color;
	CMMultichannel8Color = RECORD
		components:				PACKED ARRAY [0..7] OF UInt8;			{  0..255  }
	END;

	CMNamedColorPtr = ^CMNamedColor;
	CMNamedColor = RECORD
		namedColorIndex:		LONGINT;								{  0..a lot  }
	END;

	CMColorPtr = ^CMColor;
	CMColor = RECORD
		CASE INTEGER OF
		0: (
			rgb:				CMRGBColor;
			);
		1: (
			hsv:				CMHSVColor;
			);
		2: (
			hls:				CMHLSColor;
			);
		3: (
			XYZ:				CMXYZColor;
			);
		4: (
			Lab:				CMLabColor;
			);
		5: (
			Luv:				CMLuvColor;
			);
		6: (
			Yxy:				CMYxyColor;
			);
		7: (
			cmyk:				CMCMYKColor;
			);
		8: (
			cmy:				CMCMYColor;
			);
		9: (
			gray:				CMGrayColor;
			);
		10: (
			mc5:				CMMultichannel5Color;
			);
		11: (
			mc6:				CMMultichannel6Color;
			);
		12: (
			mc7:				CMMultichannel7Color;
			);
		13: (
			mc8:				CMMultichannel8Color;
			);
		14: (
			namedColor:			CMNamedColor;
			);
	END;

	CMProfileSearchRecordPtr = ^CMProfileSearchRecord;
	CMProfileSearchRecord = RECORD
		header:					CMHeader;
		fieldMask:				LONGINT;
		reserved:				ARRAY [0..1] OF LONGINT;
	END;

	CMProfileSearchRecordHandle			= ^CMProfileSearchRecordPtr;
{  Search definition for 2.0  }
	CMSearchRecordPtr = ^CMSearchRecord;
	CMSearchRecord = RECORD
		CMMType:				OSType;
		profileClass:			OSType;
		dataColorSpace:			OSType;
		profileConnectionSpace:	OSType;
		deviceManufacturer:		LONGINT;
		deviceModel:			LONGINT;
		deviceAttributes:		ARRAY [0..1] OF LONGINT;
		profileFlags:			LONGINT;
		searchMask:				LONGINT;
		filter:					CMProfileFilterUPP;
	END;

{  GetCWInfo structures  }
	CMMInfoRecordPtr = ^CMMInfoRecord;
	CMMInfoRecord = RECORD
		CMMType:				OSType;
		CMMVersion:				LONGINT;
	END;

	CMCWInfoRecordPtr = ^CMCWInfoRecord;
	CMCWInfoRecord = RECORD
		cmmCount:				LONGINT;
		cmmInfo:				ARRAY [0..1] OF CMMInfoRecord;
	END;


CONST
	cmNoColorPacking			= $0000;
	cmAlphaSpace				= $0080;
	cmWord5ColorPacking			= $0500;
	cmLong8ColorPacking			= $0800;
	cmLong10ColorPacking		= $0A00;
	cmAlphaFirstPacking			= $1000;
	cmOneBitDirectPacking		= $0B00;

	cmNoSpace					= 0;
	cmRGBSpace					= 1;
	cmCMYKSpace					= 2;
	cmHSVSpace					= 3;
	cmHLSSpace					= 4;
	cmYXYSpace					= 5;
	cmXYZSpace					= 6;
	cmLUVSpace					= 7;
	cmLABSpace					= 8;
	cmReservedSpace1			= 9;
	cmGraySpace					= 10;
	cmReservedSpace2			= 11;
	cmGamutResultSpace			= 12;
	cmRGBASpace					= 129;
	cmGrayASpace				= 138;
	cmRGB16Space				= $0501;
	cmRGB32Space				= $0801;
	cmARGB32Space				= $1881;
	cmCMYK32Space				= $0802;
	cmHSV32Space				= $0A03;
	cmHLS32Space				= $0A04;
	cmYXY32Space				= $0A05;
	cmXYZ32Space				= $0A06;
	cmLUV32Space				= $0A07;
	cmLAB32Space				= $0A08;
	cmGamutResult1Space			= $0B0C;


TYPE
	CMBitmapColorSpace					= LONGINT;
	CMBitmapPtr = ^CMBitmap;
	CMBitmap = RECORD
		image:					CStringPtr;
		width:					LONGINT;
		height:					LONGINT;
		rowBytes:				LONGINT;
		pixelSize:				LONGINT;
		space:					CMBitmapColorSpace;
		user1:					LONGINT;
		user2:					LONGINT;
	END;

{  Classic Print Manager Stuff  }

CONST
	enableColorMatchingOp		= 12;
	registerProfileOp			= 13;

	cmNoProfileBase				= 0;
	cmFileBasedProfile			= 1;
	cmHandleBasedProfile		= 2;
	cmPtrBasedProfile			= 3;


TYPE
	CMFileLocationPtr = ^CMFileLocation;
	CMFileLocation = RECORD
		spec:					FSSpec;
	END;

	CMHandleLocationPtr = ^CMHandleLocation;
	CMHandleLocation = RECORD
		h:						Handle;
	END;

	CMPtrLocationPtr = ^CMPtrLocation;
	CMPtrLocation = RECORD
		p:						Ptr;
	END;

	CMProfLocPtr = ^CMProfLoc;
	CMProfLoc = RECORD
		CASE INTEGER OF
		0: (
			fileLoc:			CMFileLocation;
			);
		1: (
			handleLoc:			CMHandleLocation;
			);
		2: (
			ptrLoc:				CMPtrLocation;
			);
	END;

	CMProfileLocationPtr = ^CMProfileLocation;
	CMProfileLocation = RECORD
		locType:				INTEGER;
		u:						CMProfLoc;
	END;

{  Profile file and element access  }
FUNCTION CMNewProfile(VAR prof: CMProfileRef; {CONST}VAR theProfile: CMProfileLocation): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $001B, $ABEE;
	{$ENDC}
FUNCTION CMOpenProfile(VAR prof: CMProfileRef; {CONST}VAR theProfile: CMProfileLocation): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $001C, $ABEE;
	{$ENDC}
FUNCTION CMCloseProfile(prof: CMProfileRef): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $001D, $ABEE;
	{$ENDC}
FUNCTION CMUpdateProfile(prof: CMProfileRef): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $0034, $ABEE;
	{$ENDC}
FUNCTION CMCopyProfile(VAR targetProf: CMProfileRef; {CONST}VAR targetLocation: CMProfileLocation; srcProf: CMProfileRef): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0025, $ABEE;
	{$ENDC}
FUNCTION CMValidateProfile(prof: CMProfileRef; VAR valid: BOOLEAN; VAR preferredCMMnotfound: BOOLEAN): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0026, $ABEE;
	{$ENDC}
FUNCTION CMGetProfileLocation(prof: CMProfileRef; VAR theProfile: CMProfileLocation): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $003C, $ABEE;
	{$ENDC}
FUNCTION CMFlattenProfile(prof: CMProfileRef; flags: LONGINT; proc: CMFlattenUPP; refCon: UNIV Ptr; VAR preferredCMMnotfound: BOOLEAN): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0014, $0031, $ABEE;
	{$ENDC}
FUNCTION CMUnflattenProfile(VAR resultFileSpec: FSSpec; proc: CMFlattenUPP; refCon: UNIV Ptr; VAR preferredCMMnotfound: BOOLEAN): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0010, $0032, $ABEE;
	{$ENDC}
FUNCTION CMGetProfileHeader(prof: CMProfileRef; VAR header: CMAppleProfileHeader): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $0039, $ABEE;
	{$ENDC}
FUNCTION CMSetProfileHeader(prof: CMProfileRef; {CONST}VAR header: CMAppleProfileHeader): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $003A, $ABEE;
	{$ENDC}
FUNCTION CMProfileElementExists(prof: CMProfileRef; tag: OSType; VAR found: BOOLEAN): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $001E, $ABEE;
	{$ENDC}
FUNCTION CMCountProfileElements(prof: CMProfileRef; VAR elementCount: LONGINT): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $001F, $ABEE;
	{$ENDC}
FUNCTION CMGetProfileElement(prof: CMProfileRef; tag: OSType; VAR elementSize: LONGINT; elementData: UNIV Ptr): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0010, $0020, $ABEE;
	{$ENDC}
FUNCTION CMSetProfileElement(prof: CMProfileRef; tag: OSType; elementSize: LONGINT; elementData: UNIV Ptr): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0010, $0023, $ABEE;
	{$ENDC}
FUNCTION CMSetProfileElementSize(prof: CMProfileRef; tag: OSType; elementSize: LONGINT): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0038, $ABEE;
	{$ENDC}
FUNCTION CMSetProfileElementReference(prof: CMProfileRef; elementTag: OSType; referenceTag: OSType): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0035, $ABEE;
	{$ENDC}
FUNCTION CMGetPartialProfileElement(prof: CMProfileRef; tag: OSType; offset: LONGINT; VAR byteCount: LONGINT; elementData: UNIV Ptr): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0014, $0036, $ABEE;
	{$ENDC}
FUNCTION CMSetPartialProfileElement(prof: CMProfileRef; tag: OSType; offset: LONGINT; byteCount: LONGINT; elementData: UNIV Ptr): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0014, $0037, $ABEE;
	{$ENDC}
FUNCTION CMGetIndProfileElementInfo(prof: CMProfileRef; index: LONGINT; VAR tag: OSType; VAR elementSize: LONGINT; VAR refs: BOOLEAN): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0014, $0021, $ABEE;
	{$ENDC}
FUNCTION CMGetIndProfileElement(prof: CMProfileRef; index: LONGINT; VAR elementSize: LONGINT; elementData: UNIV Ptr): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0010, $0022, $ABEE;
	{$ENDC}
FUNCTION CMRemoveProfileElement(prof: CMProfileRef; tag: OSType): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $0024, $ABEE;
	{$ENDC}
FUNCTION CMGetScriptProfileDescription(prof: CMProfileRef; VAR name: Str255; VAR code: ScriptCode): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $003E, $ABEE;
	{$ENDC}
{  Low-level matching functions  }
FUNCTION NCWNewColorWorld(VAR cw: CMWorldRef; src: CMProfileRef; dst: CMProfileRef): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0014, $ABEE;
	{$ENDC}
FUNCTION CWConcatColorWorld(VAR cw: CMWorldRef; VAR profileSet: CMConcatProfileSet): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $0015, $ABEE;
	{$ENDC}
FUNCTION CWNewLinkProfile(VAR prof: CMProfileRef; {CONST}VAR targetLocation: CMProfileLocation; VAR profileSet: CMConcatProfileSet): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0033, $ABEE;
	{$ENDC}
PROCEDURE CWDisposeColorWorld(cw: CMWorldRef);
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $0001, $ABEE;
	{$ENDC}
FUNCTION CWMatchColors(cw: CMWorldRef; VAR myColors: CMColor; count: LONGINT): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0002, $ABEE;
	{$ENDC}
FUNCTION CWCheckColors(cw: CMWorldRef; VAR myColors: CMColor; count: LONGINT; VAR result: LONGINT): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0010, $0003, $ABEE;
	{$ENDC}
{  Bitmap matching  }
FUNCTION CWMatchBitmap(cw: CMWorldRef; VAR bitmap: CMBitmap; progressProc: CMBitmapCallBackUPP; refCon: UNIV Ptr; VAR matchedBitmap: CMBitmap): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0010, $002C, $ABEE;
	{$ENDC}
FUNCTION CWCheckBitmap(cw: CMWorldRef; {CONST}VAR bitmap: CMBitmap; progressProc: CMBitmapCallBackUPP; refCon: UNIV Ptr; VAR resultBitmap: CMBitmap): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0014, $002D, $ABEE;
	{$ENDC}
{  Quickdraw-specific matching  }
FUNCTION CWMatchPixMap(cw: CMWorldRef; VAR myPixMap: PixMap; progressProc: CMBitmapCallBackUPP; refCon: UNIV Ptr): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0010, $0004, $ABEE;
	{$ENDC}
FUNCTION CWCheckPixMap(cw: CMWorldRef; VAR myPixMap: PixMap; progressProc: CMBitmapCallBackUPP; refCon: UNIV Ptr; VAR resultBitMap: BitMap): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0014, $0007, $ABEE;
	{$ENDC}
FUNCTION NCMBeginMatching(src: CMProfileRef; dst: CMProfileRef; VAR myRef: CMMatchRef): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0016, $ABEE;
	{$ENDC}
PROCEDURE CMEndMatching(myRef: CMMatchRef);
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $000B, $ABEE;
	{$ENDC}
PROCEDURE NCMDrawMatchedPicture(myPicture: PicHandle; dst: CMProfileRef; VAR myRect: Rect);
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0017, $ABEE;
	{$ENDC}
PROCEDURE CMEnableMatchingComment(enableIt: BOOLEAN);
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0002, $000D, $ABEE;
	{$ENDC}
FUNCTION NCMUseProfileComment(prof: CMProfileRef; flags: LONGINT): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $003B, $ABEE;
	{$ENDC}
{  System Profile access  }
FUNCTION CMGetSystemProfile(VAR prof: CMProfileRef): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $0018, $ABEE;
	{$ENDC}
FUNCTION CMSetSystemProfile({CONST}VAR profileFileSpec: FSSpec): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $0019, $ABEE;
	{$ENDC}
{  External Profile Management  }
FUNCTION CMNewProfileSearch(VAR searchSpec: CMSearchRecord; refCon: UNIV Ptr; VAR count: LONGINT; VAR searchResult: CMProfileSearchRef): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0010, $0027, $ABEE;
	{$ENDC}
FUNCTION CMUpdateProfileSearch(search: CMProfileSearchRef; refCon: UNIV Ptr; VAR count: LONGINT): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0028, $ABEE;
	{$ENDC}
PROCEDURE CMDisposeProfileSearch(search: CMProfileSearchRef);
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $0029, $ABEE;
	{$ENDC}
FUNCTION CMSearchGetIndProfile(search: CMProfileSearchRef; index: LONGINT; VAR prof: CMProfileRef): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $002A, $ABEE;
	{$ENDC}
FUNCTION CMSearchGetIndProfileFileSpec(search: CMProfileSearchRef; index: LONGINT; VAR profileFile: FSSpec): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $002B, $ABEE;
	{$ENDC}
{  Utilities  }
FUNCTION CMGetColorSyncFolderSpec(vRefNum: INTEGER; createFolder: BOOLEAN; VAR foundVRefNum: INTEGER; VAR foundDirID: LONGINT): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0011, $ABEE;
	{$ENDC}
FUNCTION CMGetCWInfo(cw: CMWorldRef; VAR info: CMCWInfoRecord): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $001A, $ABEE;
	{$ENDC}
{  PS-related  }
FUNCTION CMGetPS2ColorSpace(srcProf: CMProfileRef; flags: LONGINT; proc: CMFlattenUPP; refCon: UNIV Ptr; VAR preferredCMMnotfound: BOOLEAN): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0014, $002E, $ABEE;
	{$ENDC}
FUNCTION CMGetPS2ColorRenderingIntent(srcProf: CMProfileRef; flags: LONGINT; proc: CMFlattenUPP; refCon: UNIV Ptr; VAR preferredCMMnotfound: BOOLEAN): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0014, $002F, $ABEE;
	{$ENDC}
FUNCTION CMGetPS2ColorRendering(srcProf: CMProfileRef; dstProf: CMProfileRef; flags: LONGINT; proc: CMFlattenUPP; refCon: UNIV Ptr; VAR preferredCMMnotfound: BOOLEAN): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0018, $0030, $ABEE;
	{$ENDC}
FUNCTION CMGetPS2ColorRenderingVMSize(srcProf: CMProfileRef; dstProf: CMProfileRef; VAR vmSize: LONGINT; VAR preferredCMMnotfound: BOOLEAN): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0010, $003D, $ABEE;
	{$ENDC}
{  ColorSync 1.0 functions which have parallel 2.0 counterparts  }
FUNCTION CWNewColorWorld(VAR cw: CMWorldRef; src: CMProfileHandle; dst: CMProfileHandle): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0000, $ABEE;
	{$ENDC}
FUNCTION ConcatenateProfiles(thru: CMProfileHandle; dst: CMProfileHandle; VAR newDst: CMProfileHandle): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $000C, $ABEE;
	{$ENDC}
FUNCTION CMBeginMatching(src: CMProfileHandle; dst: CMProfileHandle; VAR myRef: CMMatchRef): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $000A, $ABEE;
	{$ENDC}
PROCEDURE CMDrawMatchedPicture(myPicture: PicHandle; dst: CMProfileHandle; VAR myRect: Rect);
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0009, $ABEE;
	{$ENDC}
FUNCTION CMUseProfileComment(profile: CMProfileHandle): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $0008, $ABEE;
	{$ENDC}
PROCEDURE CMGetProfileName(myProfile: CMProfileHandle; VAR IStringResult: CMIString);
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $000E, $ABEE;
	{$ENDC}
FUNCTION CMGetProfileAdditionalDataOffset(myProfile: CMProfileHandle): LONGINT;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $000F, $ABEE;
	{$ENDC}
{  ProfileResponder functions  }
FUNCTION GetProfile(deviceType: OSType; refNum: LONGINT; aProfile: CMProfileHandle; VAR returnedProfile: CMProfileHandle): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0010, $0005, $ABEE;
	{$ENDC}
FUNCTION SetProfile(deviceType: OSType; refNum: LONGINT; newProfile: CMProfileHandle): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0006, $ABEE;
	{$ENDC}
FUNCTION SetProfileDescription(deviceType: OSType; refNum: LONGINT; deviceData: LONGINT; hProfile: CMProfileHandle): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0010, $0010, $ABEE;
	{$ENDC}
FUNCTION GetIndexedProfile(deviceType: OSType; refNum: LONGINT; search: CMProfileSearchRecordHandle; VAR returnProfile: CMProfileHandle; VAR index: LONGINT): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0014, $0012, $ABEE;
	{$ENDC}
FUNCTION DeleteDeviceProfile(deviceType: OSType; refNum: LONGINT; deleteMe: CMProfileHandle): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0013, $ABEE;
	{$ENDC}
{$IFC OLDROUTINENAMES }
{  constants  }

CONST
	kMatchCMMType				= $00000001;
	kMatchApplProfileVersion	= $00000002;
	kMatchDataType				= $00000004;
	kMatchDeviceType			= $00000008;
	kMatchDeviceManufacturer	= $00000010;
	kMatchDeviceModel			= $00000020;
	kMatchDeviceAttributes		= $00000040;
	kMatchFlags					= $00000080;
	kMatchOptions				= $00000100;
	kMatchWhite					= $00000200;
	kMatchBlack					= $00000400;

{  types  }

TYPE
	CMYKColor							= CMCMYKColor;
	CMYKColorPtr 						= ^CMYKColor;
	CWorld								= CMWorldRef;
	CMGamutResult						= ^LONGINT;
{  functions  }
PROCEDURE EndMatching(myRef: CMMatchRef);
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $000B, $ABEE;
	{$ENDC}
PROCEDURE EnableMatching(enableIt: BOOLEAN);
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0002, $000D, $ABEE;
	{$ENDC}
FUNCTION GetColorSyncFolderSpec(vRefNum: INTEGER; createFolder: BOOLEAN; VAR foundVRefNum: INTEGER; VAR foundDirID: LONGINT): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0011, $ABEE;
	{$ENDC}
FUNCTION BeginMatching(src: CMProfileHandle; dst: CMProfileHandle; VAR myRef: CMMatchRef): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $000A, $ABEE;
	{$ENDC}
PROCEDURE DrawMatchedPicture(myPicture: PicHandle; dst: CMProfileHandle; VAR myRect: Rect);
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $000C, $0009, $ABEE;
	{$ENDC}
FUNCTION UseProfile(profile: CMProfileHandle): CMError;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $0008, $ABEE;
	{$ENDC}
PROCEDURE GetProfileName(myProfile: CMProfileHandle; VAR IStringResult: CMIString);
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0008, $000E, $ABEE;
	{$ENDC}
FUNCTION GetProfileAdditionalDataOffset(myProfile: CMProfileHandle): LONGINT;
	{$IFC NOT GENERATINGCFM}
	INLINE $203C, $0004, $000F, $ABEE;
	{$ENDC}
{$ENDC}
{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_DEPRECATED }
{  PrGeneral parameter blocks  }

TYPE
	TEnableColorMatchingBlkPtr = ^TEnableColorMatchingBlk;
	TEnableColorMatchingBlk = RECORD
		iOpCode:				INTEGER;
		iError:					INTEGER;
		lReserved:				LONGINT;
		hPrint:					THPrint;
		fEnableIt:				BOOLEAN;
		filler:					SInt8;
	END;

	TRegisterProfileBlkPtr = ^TRegisterProfileBlk;
	TRegisterProfileBlk = RECORD
		iOpCode:				INTEGER;
		iError:					INTEGER;
		lReserved:				LONGINT;
		hPrint:					THPrint;
		fRegisterIt:			BOOLEAN;
		filler:					SInt8;
	END;

{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := CMApplicationIncludes}

{$ENDC} {__CMAPPLICATION__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
