{
 	File:		Dictionary.p
 
 	Contains:	Dictionary Manager Interfaces
 
 	Version:	Technology:	System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT Dictionary;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __DICTIONARY__}
{$SETC __DICTIONARY__ := 1}

{$I+}
{$SETC DictionaryIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}
{$IFC FOR_SYSTEM8_PREEMPTIVE }
{$IFC UNDEFINED __AEDATAMODEL__}
{$I AEDataModel.p}
{$ENDC}
{$IFC UNDEFINED __AEREGISTRY__}
{$I AERegistry.p}
{$ENDC}
{$IFC UNDEFINED __FILEMANAGERTYPES__}
{$I FileManagerTypes.p}
{$ENDC}
{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_DEPRECATED }
{$IFC UNDEFINED __FILES__}
{$I Files.p}
{$ENDC}
{$ENDC}

{$PUSH}
{$ALIGN POWER}
{$LibExport+}

{
=============================================================================================
 System 8 Dictionary Manager
=============================================================================================
}
{$IFC FOR_SYSTEM8_PREEMPTIVE }

TYPE
	DCMUniqueID							= UInt32;
{$IFC FOR_PTR_BASED_AE }
	DCMFieldDataList					= AERecord;
	DCMFieldDataListPtr 				= ^DCMFieldDataList;
{$ENDC}
	DCMObjectID = ^LONGINT;
	DCMAccessMethodID					= DCMObjectID;
	DCMDictionaryID						= DCMObjectID;

CONST
	kDCMInvalidObjectID			= 0;


TYPE
	DCMObjectRef = ^LONGINT;
	DCMDictionaryRef					= DCMObjectRef;
	DCMDictionaryStreamRef				= DCMObjectRef;
	DCMFieldInfoRef						= DCMObjectRef;

CONST
	kDCMInvalidObjectRef		= 0;


TYPE
	DCMObjectIterator = ^LONGINT;
	DCMAccessMethodIterator				= DCMObjectIterator;
	DCMDictionaryIterator				= DCMObjectIterator;
	DCMFoundRecordIterator = ^LONGINT;
{
	Field specification declarations
}
	DCMFieldTag							= FourCharCode;
	DCMFieldType						= FourCharCode;
	DCMFieldSubType						= UInt64;
	DCMFieldSubTypePtr 					= ^DCMFieldSubType;

CONST
	kDCMAnyFieldTag				= '****';
	kDCMAnyFieldType			= '****';

{
	Dictionary information
}
	kDCMDictionaryHeaderVersion	= 1;


TYPE
	DCMDictionaryHeaderPtr = ^DCMDictionaryHeader;
	DCMDictionaryHeader = RECORD
		headerSignature:		FourCharCode;
		headerVersion:			UInt32;
		headerSize:				ByteCount;
		accessMethod:			Str63;
	END;

	DCMFieldAttribute					= OptionBits;

CONST
	kDCMIndexedFieldMask		= $00000001;
	kDCMRequiredFieldMask		= $00000002;
	kDCMIdentifyFieldMask		= $00000004;
	kDCMFixedSizeFieldMask		= $00000008;
	kDCMHiddenFieldMask			= $80000000;

{
	Standard dictionary properties
}
																{  created/updated by AccessMethod. }
																{  data type: typeSInt16 }
	kDCMPermissionPropertyTag	= 'perm';						{  created/updated by AccessMethod. }
																{  data type: typeSInt16 }
	kDCMMaintenancePropertyTag	= 'mtnc';						{  created by AccessMethod. default = kLocaleIdentifierWildCard. }
																{  data type: typeUInt32 }
	kDCMLocalePropertyTag		= 'locl';						{  optional. }
																{  data type: typeType }
	kDCMClassPropertyTag		= 'clas';						{  optional. }
																{  data type: typeChar (ASCII string) }
	kDCMCopyrightPropertyTag	= 'info';

{
	'perm' property constants
}
	kDCMReadOnlyDictionary		= 0;
	kDCMReadWriteDictionary		= 1;
	kDCMFrozenDictionary		= 2;

{
	Standard search method
}

TYPE
	DCMFindMethodType					= OSType;

CONST
	kDCMExactMatchMethod		= '=   ';
	kDCMBeginningMatchMethod	= 'bgwt';
	kDCMContainsMatchMethod		= 'cont';
	kDCMEndingMatchMethod		= 'ends';
	kDCMForwardTrieMethod		= 'ftri';						{  used for morphological analysis }
	kDCMBackwardTrieMethod		= 'btri';						{  used for morphological analysis }

{
	AccessMethod features
}

TYPE
	DCMAccessMethodFeature				= OptionBits;

CONST
	kDCMCanUseFileDictionaryMask = $00000001;
	kDCMCanUseMemoryDictionaryMask = $00000002;
	kDCMCanStreamDictionaryMask	= $00000004;
	kDCMCanHaveMultipleIndexMask = $00000008;
	kDCMCanModifyDictionaryMask	= $00000010;
	kDCMCanCreateDictionaryMask	= $00000020;
	kDCMCanAddDictionaryFieldMask = $00000040;
	kDCMCanUseTransactionMask	= $00000080;

{
	Error values
}
	dcmParamErr					= -7100;						{  bad parameter }
	dcmNotDictionaryErr			= -7101;						{  not dictionary }
	dcmBadDictionaryErr			= -7102;						{  invalid dictionary }
	dcmPermissionErr			= -7103;						{  invalid permission }
	dcmDictionaryNotOpenErr		= -7104;						{  dictionary not opened }
	dcmDictionaryBusyErr		= -7105;						{  dictionary is busy }
	dcmBadDictionaryTypeErr		= -7106;						{  bad dictionary type }
	dcmBlockFullErr				= -7107;						{  dictionary block full }
	dcmNoRecordErr				= -7108;						{  no such record }
	dcmDupRecordErr				= -7109;						{  same record already exist }
	dcmNecessaryFieldErr		= -7110;						{  lack required/identify field }
	dcmBadFieldInfoErr			= -7111;						{  incomplete information }
	dcmBadFieldTypeErr			= -7112;						{  no such field type supported }
	dcmNoFieldErr				= -7113;						{  no such field exist }
	dcmDupFieldErr				= -7114;						{  field already exist }
	dcmBadKeyErr				= -7115;						{  bad key information }
	dcmTooManyKeyErr			= -7116;						{  too many key field }
	dcmBadDataSizeErr			= -7117;						{  too big data size }
	dcmBadFindMethodErr			= -7118;						{  no such find method supported }
	dcmBadPropertyErr			= -7119;						{  no such property exist }
	dcmEndOfStreamErr			= -7120;						{  reaches end of stream }
	dcmProtectedErr				= -7121;						{  need keyword to use dictionary }
	dcmNoAccessMethodErr		= -7122;						{  no such AccessMethod }
	dcmDupAccessMethodErr		= -7123;						{  AccessMethod already exist }
	dcmBadFeatureErr			= -7124;						{  invalid AccessMethod feature }
	dcmAccessMethodBusyErr		= -7125;						{  AccessMethod is busy }
	dcmIterationCompleteErr		= -7126;						{  no more item in iterator }
	dcmBufferOverflowErr		= -7127;						{  data is larger than buffer size }
	dcmChangesCommittedErr		= -7128;						{  changes cannot be backed out }

{
	Callback routines
}

TYPE
	DCMRegisterStreamProc = ProcPtr;  { FUNCTION DCMRegisterStreamProc(refcon: UNIV Ptr; maxSize: ByteCount; VAR actualSize: ByteCount; buffer: LogicalAddress): OSStatus; C; }

	DCMProgressProc = ProcPtr;  { FUNCTION DCMProgressProc(refcon: UNIV Ptr; determinateProcess: BOOLEAN; percentageComplete: UInt16): BOOLEAN; C; }

{
	Create dictionary
}
FUNCTION DCMNewDictionary(accessMethod: DCMAccessMethodID; containerRef: FSObjectRef; dictionaryName: ConstFSName; numOfField: ItemCount; {CONST}VAR field: DCMFieldInfoRef; invisible: BOOLEAN; recordCapacity: ItemCount; VAR newDictionary: DCMDictionaryID): OSStatus; C;
FUNCTION DCMDeriveNewDictionary(srcDictionary: DCMDictionaryID; containerRef: FSObjectRef; dictionaryName: ConstFSName; invisible: BOOLEAN; recordCapacity: ItemCount; VAR newDictionary: DCMDictionaryID): OSStatus; C;
{
	Register dictionary
}
FUNCTION DCMRegisterDictionaryFile(dictionaryFile: FSObjectRef; VAR dictionaryID: DCMDictionaryID): OSStatus; C;
FUNCTION DCMRegisterDictionaryStream(myRegisterProc: DCMRegisterStreamProc; refcon: UNIV Ptr; dictionarySize: ByteCount; VAR dictionaryID: DCMDictionaryID): OSStatus; C;
FUNCTION DCMUnregisterDictionary(dictionaryID: DCMDictionaryID): OSStatus; C;
{
	Open dictionary
}
FUNCTION DCMOpenDictionary(dictionaryID: DCMDictionaryID; protectKeySize: ByteCount; protectKey: LogicalAddress; VAR dictionaryRef: DCMDictionaryRef): OSStatus; C;
FUNCTION DCMCloseDictionary(dictionaryRef: DCMDictionaryRef): OSStatus; C;
{
	Change access privilege
}
FUNCTION DCMGetDictionaryWriteAccess(dictionaryRef: DCMDictionaryRef; timeOutDuration: Duration): OSStatus; C;
FUNCTION DCMReleaseDictionaryWriteAccess(dictionaryRef: DCMDictionaryRef; commitTransaction: BOOLEAN): OSStatus; C;
{
	Find records
}
FUNCTION DCMFindRecords(dictionaryRef: DCMDictionaryRef; keyFieldTag: DCMFieldTag; keySize: ByteCount; keyData: ConstLogicalAddress; findMethod: DCMFindMethodType; preFetchedDataNum: ItemCount; VAR preFetchedData: DCMFieldTag; skipCount: ItemCount; maxRecordCount: ItemCount; VAR recordIterator: DCMFoundRecordIterator): OSStatus; C;
FUNCTION DCMCountRecordIterator(recordIterator: DCMFoundRecordIterator): ItemCount; C;
{$IFC FOR_PTR_BASED_AE }
FUNCTION DCMIterateFoundRecord(recordIterator: DCMFoundRecordIterator; maxKeySize: ByteCount; VAR actualKeySize: ByteCount; keyData: LogicalAddress; VAR uniqueID: DCMUniqueID; VAR dataList: DCMFieldDataList): OSStatus; C;
{$ENDC}
FUNCTION DCMDisposeRecordIterator(recordIterator: DCMFoundRecordIterator): OSStatus; C;
{
	Dump dictionary
}
FUNCTION DCMGetNextRecord(dictionaryRef: DCMDictionaryRef; keyFieldTag: DCMFieldTag; keySize: ByteCount; keyData: ConstLogicalAddress; uniqueID: DCMUniqueID; maxKeySize: ByteCount; VAR nextKeySize: ByteCount; nextKeyData: LogicalAddress; VAR nextUniqueID: DCMUniqueID): OSStatus; C;
FUNCTION DCMGetPrevRecord(dictionaryRef: DCMDictionaryRef; keyFieldTag: DCMFieldTag; keySize: ByteCount; keyData: ConstLogicalAddress; uniqueID: DCMUniqueID; maxKeySize: ByteCount; VAR prevKeySize: ByteCount; prevKeyData: LogicalAddress; VAR prevUniqueID: DCMUniqueID): OSStatus; C;
FUNCTION DCMGetNthRecord(dictionaryRef: DCMDictionaryRef; keyFieldTag: DCMFieldTag; serialNum: ItemCount; maxKeySize: ByteCount; VAR keySize: ByteCount; keyData: LogicalAddress; VAR uniqueID: DCMUniqueID): OSStatus; C;
FUNCTION DCMGetRecordSequenceNumber(dictionaryRef: DCMDictionaryRef; keyFieldTag: DCMFieldTag; keySize: ByteCount; keyData: ConstLogicalAddress; uniqueID: DCMUniqueID; VAR sequenceNum: ItemCount): OSStatus; C;
{
	Get field data
}
{$IFC FOR_PTR_BASED_AE }
FUNCTION DCMGetFieldData(dictionaryRef: DCMDictionaryRef; keyFieldTag: DCMFieldTag; keySize: ByteCount; keyData: ConstLogicalAddress; uniqueID: DCMUniqueID; numOfData: ItemCount; {CONST}VAR dataTag: DCMFieldTag; VAR dataList: DCMFieldDataList): OSStatus; C;
FUNCTION DCMSetFieldData(dictionaryRef: DCMDictionaryRef; keyFieldTag: DCMFieldTag; keySize: ByteCount; keyData: ConstLogicalAddress; uniqueID: DCMUniqueID; dataList: DCMFieldDataList): OSStatus; C;
{$ENDC}
FUNCTION DCMAnnotateTextObjectWithFieldData(dictionaryRef: DCMDictionaryRef; keyTag: DCMFieldTag; uniqueID: DCMUniqueID; numDataField: ItemCount; {CONST}VAR data: DCMFieldTag; keyText: TextObject): OSStatus; C;
{
	Add record
}
{$IFC FOR_PTR_BASED_AE }
FUNCTION DCMAddRecord(dictionaryRef: DCMDictionaryRef; keyFieldTag: DCMFieldTag; keySize: ByteCount; keyData: ConstLogicalAddress; checkOnly: BOOLEAN; dataList: DCMFieldDataList; VAR newUniqueID: DCMUniqueID): OSStatus; C;
{$ENDC}
FUNCTION DCMDeleteRecord(dictionaryRef: DCMDictionaryRef; keyFieldTag: DCMFieldTag; keySize: ByteCount; keyData: ConstLogicalAddress; uniqueID: DCMUniqueID): OSStatus; C;
FUNCTION DCMCopyRecord(srcDictionary: DCMDictionaryRef; keyFieldTag: DCMFieldTag; keySize: ByteCount; keyData: ConstLogicalAddress; uniqueID: DCMUniqueID; targetDictionary: DCMDictionaryRef; checkOnly: BOOLEAN; VAR newUniqueID: DCMUniqueID): OSStatus; C;
{
	Add field
}
FUNCTION DCMAddField(dictionaryID: DCMDictionaryID; fieldInfo: DCMFieldInfoRef; progressProcPtr: DCMProgressProc; procRefcon: UNIV Ptr): OSStatus; C;
FUNCTION DCMDeleteField(dictionaryID: DCMDictionaryID; fieldTag: DCMFieldTag; progressProcPtr: DCMProgressProc; procRefcon: UNIV Ptr): OSStatus; C;
{
	Get dictionary information
}
FUNCTION DCMCountRecord(dictionaryID: DCMDictionaryID; VAR count: ItemCount): OSStatus; C;
FUNCTION DCMGetDictionaryInformarion(dictionaryID: DCMDictionaryID; VAR accessMethod: DCMAccessMethodID; VAR isProtected: BOOLEAN): OSStatus; C;
FUNCTION DCMGetDictionaryFieldList(dictionaryID: DCMDictionaryID; maxFieldNum: ItemCount; VAR actualFieldNum: ItemCount; VAR fieldTag: DCMFieldTag; VAR fieldType: DCMFieldType): OSStatus; C;
FUNCTION DCMGetDictionaryFieldInfo(dictionaryID: DCMDictionaryID; fieldTag: DCMFieldTag; fieldInfo: DCMFieldInfoRef): OSStatus; C;
FUNCTION DCMGetFileRefFromDictionaryID(dictionaryID: DCMDictionaryID; VAR fileRef: FSObjectRef): OSStatus; C;
FUNCTION DCMGetDictionaryIDFromFile(fileRef: FSObjectRef; VAR dictionaryID: DCMDictionaryID): OSStatus; C;
FUNCTION DCMGetDictionaryIDFromRef(dictionaryRef: DCMDictionaryRef): DCMDictionaryID; C;
FUNCTION DCMGetDictionaryChangeCount(dictionaryID: DCMDictionaryID): UInt32; C;
{
	Dictionary property
}
FUNCTION DCMGetDictionaryProperty(dictionaryID: DCMDictionaryID; propertyTag: DCMFieldTag; maxPropertySize: ByteCount; VAR actualSize: ByteCount; propertyValue: LogicalAddress): OSStatus; C;
FUNCTION DCMSetDictionaryProperty(dictionaryID: DCMDictionaryID; propertyTag: DCMFieldTag; propertySize: ByteCount; propertyValue: ConstLogicalAddress): OSStatus; C;
FUNCTION DCMGetDictionaryPropertyList(dictionaryID: DCMDictionaryID; maxPropertyNum: ItemCount; VAR numProperties: ItemCount; VAR propertyTag: DCMFieldTag): OSStatus; C;
{
	Get dictionary stream
}
FUNCTION DCMCreateDictionaryStream(dictionaryID: DCMDictionaryID; VAR stream: DCMDictionaryStreamRef): OSStatus; C;
FUNCTION DCMReadDictionaryStream(stream: DCMDictionaryStreamRef; maxSize: ByteCount; VAR actualSize: ByteCount; buffer: LogicalAddress): OSStatus; C;
FUNCTION DCMDisposeDictionaryStream(stream: DCMDictionaryStreamRef): OSStatus; C;
{
	Reorganize/compact dictionary
}
FUNCTION DCMReorganizeDictionary(dictionaryID: DCMDictionaryID; extraCapacity: ItemCount; progressProcPtr: DCMProgressProc; procRefcon: UNIV Ptr): OSStatus; C;
FUNCTION DCMFreezeDictionary(dictionaryID: DCMDictionaryID; progressProcPtr: DCMProgressProc; procRefcon: UNIV Ptr): OSStatus; C;
FUNCTION DCMUnfreezeDictionary(dictionaryID: DCMDictionaryID; extraCapacity: ItemCount; progressProcPtr: DCMProgressProc; procRefcon: UNIV Ptr): OSStatus; C;
{
	Seaarch dictionary
}
FUNCTION DCMCreateDictionaryIterator(VAR dictionaryIterator: DCMDictionaryIterator): OSStatus; C;
FUNCTION DCMFindDictionaryByField(desiredTag: DCMFieldTag; desiredType: DCMFieldType; attributeMask: DCMFieldAttribute; numOfFindMethod: ItemCount; {CONST}VAR neededMethods: DCMFindMethodType; requiredFieldSize: ByteCount; dataTypeTranslation: BOOLEAN; writeFieldData: BOOLEAN; findProtected: BOOLEAN; dictionaryIterator: DCMDictionaryIterator): OSStatus; C;
FUNCTION DCMFindDictionaryByProperty(propertyTag: DCMFieldTag; propertySize: ByteCount; propertyValue: ConstLogicalAddress; dictionaryIterator: DCMDictionaryIterator): OSStatus; C;
{
	Search AccessMethod
}
FUNCTION DCMCreateAccessMethodIterator(VAR accessMethodIterator: DCMAccessMethodIterator): OSStatus; C;
FUNCTION DCMFindAccessMethodByField(fieldType: DCMFieldType; keyField: BOOLEAN; numOfFindMethod: ItemCount; {CONST}VAR neededMethods: DCMFindMethodType; requiredSize: ByteCount; dataTypeTranslation: BOOLEAN; accessMethodIterator: DCMAccessMethodIterator): OSStatus; C;
FUNCTION DCMFindAccessMethodByFeature(neededFeature: DCMAccessMethodFeature; accessMethodIterator: DCMAccessMethodIterator): OSStatus; C;
{
	Iterator Operation
}
FUNCTION DCMCountObjectIterator(iterator: DCMObjectIterator): ItemCount; C;
FUNCTION DCMIterateObject(iterator: DCMObjectIterator; VAR objectID: DCMObjectID): OSStatus; C;
FUNCTION DCMResetObjectIterator(iterator: DCMObjectIterator): OSStatus; C;
FUNCTION DCMDisposeObjectIterator(iterator: DCMObjectIterator): OSStatus; C;
{
	Register AccessMethod
}
FUNCTION DCMRegisterAccessMethod(accessMethodFile: FSObjectRef; maxAccessMethodNum: ItemCount; VAR accessMethodNum: ItemCount; VAR accessMethod: DCMAccessMethodID): OSStatus; C;
FUNCTION DCMUnregisterAccessMethod(accessMethod: DCMAccessMethodID): OSStatus; C;
{
	Get AccessMethod information
}
FUNCTION DCMGetAccessMethodInformation(accessMethod: DCMAccessMethodID; maxNameLen: ByteCount; VAR nameLength: ByteCount; libraryName: LogicalAddress; VAR version: UInt32; VAR feature: DCMAccessMethodFeature): OSStatus; C;
FUNCTION DCMGetAccessMethodFieldInfoList(accessMethod: DCMAccessMethodID; maxFieldNum: ItemCount; VAR numOfField: ItemCount; VAR fieldInfo: DCMFieldInfoRef): OSStatus; C;
{
	Operators for DCMFieldInfoRef
}
FUNCTION DCMCreateFieldInfoRef(VAR fieldInfo: DCMFieldInfoRef): OSStatus; C;
FUNCTION DCMDisposeFieldInfoRef(fieldInfo: DCMFieldInfoRef): OSStatus; C;
FUNCTION DCMSetFieldInfoTagType(fieldInfo: DCMFieldInfoRef; fieldTag: DCMFieldTag; fieldType: DCMFieldType; {CONST}VAR subType: DCMFieldSubType): OSStatus; C;
FUNCTION DCMSetFieldInfoMaxSize(fieldInfo: DCMFieldInfoRef; maximumSize: ByteCount): OSStatus; C;
FUNCTION DCMSetFieldInfoAttribute(fieldInfo: DCMFieldInfoRef; attribute: DCMFieldAttribute): OSStatus; C;
FUNCTION DCMSetFieldInfoName(fieldInfo: DCMFieldInfoRef; numOfName: ItemCount; {CONST}VAR fieldName: ConstTextObject): OSStatus; C;
FUNCTION DCMSetFieldInfoFindType(fieldInfo: DCMFieldInfoRef; numOfType: ItemCount; VAR findMethodType: DCMFindMethodType): OSStatus; C;
FUNCTION DCMSetFieldInfoFindName(fieldInfo: DCMFieldInfoRef; findMethodType: DCMFindMethodType; numOfName: ItemCount; {CONST}VAR findMethodName: ConstTextObject): OSStatus; C;
FUNCTION DCMSetFieldInfoDefaultData(fieldInfo: DCMFieldInfoRef; dataSize: ByteCount; defaultData: ConstLogicalAddress): OSStatus; C;
FUNCTION DCMGetFieldInfoTagType(fieldInfo: DCMFieldInfoRef; VAR fieldTag: DCMFieldTag; VAR fieldType: DCMFieldType; VAR subType: DCMFieldSubType): OSStatus; C;
FUNCTION DCMGetFieldInfoMaxSize(fieldInfo: DCMFieldInfoRef; VAR maximumSize: ByteCount): OSStatus; C;
FUNCTION DCMGetFieldInfoAttribute(fieldInfo: DCMFieldInfoRef; VAR attribute: DCMFieldAttribute): OSStatus; C;
FUNCTION DCMGetFieldInfoName(fieldInfo: DCMFieldInfoRef; nameLocale: LocaleIdentifier; fieldName: TextObject): OSStatus; C;
FUNCTION DCMGetFieldInfoNameList(fieldInfo: DCMFieldInfoRef; maxNameNum: ItemCount; VAR numOfName: ItemCount; VAR fieldName: TextObject): OSStatus; C;
FUNCTION DCMGetFieldInfoFindTypeList(fieldInfo: DCMFieldInfoRef; maxMethodNum: ItemCount; VAR numOfMethod: ItemCount; VAR findMethodType: DCMFindMethodType): OSStatus; C;
FUNCTION DCMGetFieldInfoFindName(fieldInfo: DCMFieldInfoRef; findMethodType: DCMFindMethodType; nameLocale: LocaleIdentifier; findMethodName: TextObject): OSStatus; C;
FUNCTION DCMGetFieldInfoFindNameList(fieldInfo: DCMFieldInfoRef; findMethodType: DCMFindMethodType; maxNameNum: ItemCount; VAR numOfName: ItemCount; VAR findMethodName: TextObject): OSStatus; C;
FUNCTION DCMGetFieldInfoDefaultData(fieldInfo: DCMFieldInfoRef; maxDataSize: ByteCount; VAR actualSize: ByteCount; defaultData: LogicalAddress): OSStatus; C;
{
	API for AccessMethod only
}
FUNCTION DCMAddFoundRecordToIterator(keySize: ByteCount; keyData: ConstLogicalAddress; uniqueID: DCMUniqueID; VAR fieldType: DCMFieldType; VAR dataSize: ByteCount; VAR data: ConstLogicalAddress; recordIterator: DCMFoundRecordIterator): OSStatus; C;
{$ENDC}
{
=============================================================================================
 System 7 Dictionary Manager
=============================================================================================
}
{$ALIGN MAC68K}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_DEPRECATED }

CONST
																{  Dictionary data insertion modes  }
	kInsert						= 0;							{  Only insert the input entry if there is nothing in the dictionary that matches the key.  }
	kReplace					= 1;							{  Only replace the entries which match the key with the input entry.  }
	kInsertOrReplace			= 2;							{  Insert the entry if there is nothing in the dictionary which matches the key, otherwise replaces the existing matched entries with the input entry.  }

{  This Was InsertMode  }

TYPE
	DictionaryDataInsertMode			= INTEGER;

CONST
																{  Key attribute constants  }
	kIsCaseSensitive			= $10;							{  case sensitive = 16		 }
	kIsNotDiacriticalSensitive	= $20;							{  diac not sensitive = 32	 }

																{  Registered attribute type constants.	 }
	kNoun						= -1;
	kVerb						= -2;
	kAdjective					= -3;
	kAdverb						= -4;

{  This Was AttributeType  }

TYPE
	DictionaryEntryAttribute			= SInt8;
{  Dictionary information record  }
	DictionaryInformationPtr = ^DictionaryInformation;
	DictionaryInformation = RECORD
		dictionaryFSSpec:		FSSpec;
		numberOfRecords:		SInt32;
		currentGarbageSize:		SInt32;
		script:					ScriptCode;
		maximumKeyLength:		SInt16;
		keyAttributes:			SInt8;
	END;

	DictionaryAttributeTablePtr = ^DictionaryAttributeTable;
	DictionaryAttributeTable = PACKED RECORD
		datSize:				UInt8;
		datTable:				ARRAY [0..0] OF DictionaryEntryAttribute;
	END;

FUNCTION InitializeDictionary({CONST}VAR theFsspecPtr: FSSpec; maximumKeyLength: SInt16; keyAttributes: SInt8; script: ScriptCode): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0500, $AA53;
	{$ENDC}
FUNCTION OpenDictionary({CONST}VAR theFsspecPtr: FSSpec; accessPermission: SInt8; VAR dictionaryReference: SInt32): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0501, $AA53;
	{$ENDC}
FUNCTION CloseDictionary(dictionaryReference: SInt32): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0202, $AA53;
	{$ENDC}
FUNCTION InsertRecordToDictionary(dictionaryReference: SInt32; key: Str255; recordDataHandle: Handle; whichMode: DictionaryDataInsertMode): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0703, $AA53;
	{$ENDC}
FUNCTION DeleteRecordFromDictionary(dictionaryReference: SInt32; key: Str255): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0404, $AA53;
	{$ENDC}
FUNCTION FindRecordInDictionary(dictionaryReference: SInt32; key: Str255; requestedAttributeTablePointer: DictionaryAttributeTablePtr; recordDataHandle: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0805, $AA53;
	{$ENDC}
FUNCTION FindRecordByIndexInDictionary(dictionaryReference: SInt32; recordIndex: SInt32; requestedAttributeTablePointer: DictionaryAttributeTablePtr; VAR recordKey: Str255; recordDataHandle: Handle): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0A06, $AA53;
	{$ENDC}
FUNCTION GetDictionaryInformation(dictionaryReference: SInt32; VAR theDictionaryInformation: DictionaryInformation): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0407, $AA53;
	{$ENDC}
FUNCTION CompactDictionary(dictionaryReference: SInt32): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0208, $AA53;
	{$ENDC}
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := DictionaryIncludes}

{$ENDC} {__DICTIONARY__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
