{
 	File:		HIWindowTypes.p
 
 	Version:	Technology:	Copland
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT HIWindowTypes;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __HIWINDOWTYPES__}
{$SETC __HIWINDOWTYPES__ := 1}

{$I+}
{$SETC HIWindowTypesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}

{$PUSH}
{$ALIGN POWER}
{$LibExport+}

{$IFC FOR_SYSTEM8_COOPERATIVE }

TYPE
	HIWindow = ^LONGINT;
	HIWindowPtr							= ^HIWindow;
	HILayerRef = ^LONGINT;
	HIWindowGroupRef = ^LONGINT;

CONST
	kHIStateChangeWindowZOrderChanging = 'z1  ';				{  new state-changed codes for windows }
	kHIStateChangeWindowZOrderChanged = 'z2  ';
	kHIStateChangeWindowCollapsed = 'clps';
	kHIStateChangeWindowExpanded = 'expn';
	kHIBehindWindowTag			= 'bwnd';						{  during z-order changing callback, new behindWindow is found at [tag: kHIBehindWindowTag, index: 1] }

{  Window class encompasses window frame style, z-order, and default system behavior }

TYPE
	HIWindowClass						= UInt32;

CONST
	kHIWindowModalClass			= 0;
	kHIWindowFloatingClass		= 1;
	kHIWindowNormalClass		= 2;

{  Different types of windows in each window class }

TYPE
	HIWindowVariant						= UInt32;

CONST
	kHIWindowDocumentVariant	= 0;							{  following are for use with kHIWindowNormalClass }
	kHIWindowModalDialogVariant	= 1;
	kHIWindowPlainDialogVariant	= 2;
	kHIWindowShadowDialogVariant = 3;
	kHIWindowMovableModalDialogVariant = 5;
	kHIWindowAlertVariant		= 7;
	kHIWindowMovableAlertVariant = 9;
	kHIWindowBorderlessNormalVariant = 10;
	kHIWindowStandardFloaterVariant = 0;						{  for use with kHIWindowFloatingClass }
	kHIWindowBorderlessFloaterVariant = 1;
	kHIWindowSideFloaterVariant	= 8;

{  Attributes for any window }

TYPE
	HIWindowAttributes					= OptionBits;

CONST
	kHIWindowHasGrow			= $00000001;
	kHIWindowRightToLeftOrientation = $00000002;
	kHIWindowPreventsProcessSwitching = $00000004;
	kHIWindowHasHorizontalZoom	= $00000008;
	kHIWindowHasVerticalZoom	= $00000010;
	kHIWindowHasFullZoom		= $00000018;
	kHIWindowHasClose			= $00000020;
	kHIWindowDoesTitleIconDrag	= $00000040;
	kHIWindowHasCollapse		= $00000080;
	kHIWindowDoNotEraseContent	= $00000100;
	kHIWindowNoUpdateEvents		= $00000200;
	kHIWindowNoActivateEvents	= $00000400;
	kHIWindowWantsBackgroundContentClicks = $00000800;
	kHIWindowAutomaticAlignment	= $00001000;
	kHIWindowQuitOnClose		= $00002000;
	kHIWindowHasCloseBox		= $00000020;					{  names without "Box" are preferred }
	kHIWindowHasCollapseBox		= $00000080;
	kHIWindowReservedAttributes	= $FFFFC000;
	kHIWindowStandardDocumentAttributes = $000000F9;
	kHIWindowStandardUtilityAttributes = $000000A0;

{  Parameters for the behindThisWindow argument of InitWindow/InitWindowInLayer }
	kHIFirstWindowOfClass		= -1;
	kHILastWindowOfClass		= 0;

{  Parameters for the rootPanel argument of InitWindow/InitWindowInLayer }
	kHIWindowDefaultRootPanel	= -1;
	kHIWindowNoRootPanel		= 0;

{  Vertical, horizontal, and location constraints are used with PositionOnScreen and AutoPosition }

TYPE
	HIWindowVerticalConstraint			= UInt32;

CONST
	kHIWindowNoVerticalConstraint = 0;
	kHIWindowDocumentVerticalCenter = 1;
	kHIWindowAlertVerticalCenter = 2;
	kHIWindowVerticalStagger	= 3;


TYPE
	HIWindowHorizontalConstraint		= UInt32;

CONST
	kHIWindowNoHorizontalConstraint = 0;
	kHIWindowHorizontalCenter	= 1;


TYPE
	HIWindowLocationConstraint			= UInt32;

CONST
	kHIWindowMainScreen			= 0;
	kHIWindowParentWindowScreen	= 1;
	kHIWindowParentWindow		= 2;

{ Parts of a window frame }

TYPE
	HIWindowPartCode					= SInt32;

CONST
	kHIWindowFramePart			= -1;							{  for use only with IsPositionedOnScreen }
	kHIWindowNoPart				= 0;
	kHIWindowContentPart		= 1;
	kHIWindowDragPart			= 2;
	kHIWindowGrowPart			= 3;
	kHIWindowClosePart			= 4;
	kHIWindowZoomInPart			= 5;
	kHIWindowZoomOutPart		= 6;
	kHIWindowCustomBoxPart		= 7;
	kHIWindowTitleIconPart		= 8;
	kHIWindowCollapsePart		= 9;

{  Similar to window part codes, but with slightly finer granularity }

TYPE
	HIWindowRgnCode						= UInt32;

CONST
	kHIWindowTitleBarRgn		= 0;
	kHIWindowTitleTextRgn		= 1;
	kHIWindowCloseBoxRgn		= 2;
	kHIWindowZoomBoxRgn			= 3;
	kHIWindowIconBoxRgn			= 4;
	kHIWindowDragRgn			= 5;
	kHIWindowGrowRgn			= 6;
	kHIWindowCollapseBoxRgn		= 7;
	kHIWindowStructureRgn		= 32;
	kHIWindowContentRgn			= 33;

{ Returned by GetGrowDirection }

TYPE
	HIWindowGrowDirection				= OptionBits;

CONST
	kHIWindowGrowUp				= $01;
	kHIWindowGrowLeft			= $02;
	kHIWindowGrowDown			= $04;
	kHIWindowGrowRight			= $08;

{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := HIWindowTypesIncludes}

{$ENDC} {__HIWINDOWTYPES__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
