{
 	File:		LanguageAnalysis.p
 
 	Contains:	Language Analysis Manager Interfaces
 
 	Version:	Technology:	System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT LanguageAnalysis;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __LANGUAGEANALYSIS__}
{$SETC __LANGUAGEANALYSIS__ := 1}

{$I+}
{$SETC LanguageAnalysisIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}
{$IFC UNDEFINED __AEDATAMODEL__}
{$I AEDataModel.p}
{$ENDC}
{$IFC UNDEFINED __AEREGISTRY__}
{$I AERegistry.p}
{$ENDC}
{$IFC UNDEFINED __FILEMANAGERTYPES__}
{$I FileManagerTypes.p}
{$ENDC}
{$IFC UNDEFINED __LOCALEOBJECTS__}
{$I LocaleObjects.p}
{$ENDC}
{$IFC UNDEFINED __DICTIONARY__}
{$I Dictionary.p}
{$ENDC}

{$PUSH}
{$ALIGN POWER}
{$LibExport+}

{$IFC FOR_SYSTEM8_PREEMPTIVE }
{$IFC FOR_PTR_BASED_AE }

TYPE
	LAItemOffset						= UInt32;
	LAEnvironmentLocaleObjectRef		= LocaleObjectRef;
	LAContextRef = ^LONGINT;
	LAPropertyKey						= AEKeyword;
	LAPropertyType						= DescType;
{
	Names for Environment Locale Object Attribute Names and Values
}
{  Japanese Kana-Kanji conversion }
{  Japanese TTS }
{  General Morpheme Analysis }
{
	Tags for Environment Properties
}

CONST
	keyAELAAutoLearning			= 'laal';						{  Boolean }
	keyAELALearningDictionary	= 'lald';						{  Some permanent file specification }
	keyAELADictionaryList		= 'ladc';						{  AEList which has a list of dictionary informaion. }

{
	Tags for dictionary information
}
	keyAELADictionaryFile		= 'dfil';						{  Some permanent file specification }
	keyAELADictionaryWeight		= 'dwgt';						{  Int32 }
	keyAELADictionaryID			= 'did ';						{  DictionaryID (r/o, volatile) }


TYPE
	LAMorphemeBundle					= AERecord;
	LAMorphemeBundlePtr 				= ^LAMorphemeBundle;
	LAMorphemePath						= AERecord;
	LAMorphemePathPtr 					= ^LAMorphemePath;
	LAMorpheme							= AERecord;
	LAMorphemePtr 						= ^LAMorpheme;
	LAHomograph							= AERecord;
	LAHomographPtr 						= ^LAHomograph;

CONST
	typeLAMorphemeBundle		= 'lmfb';
	typeLAMorphemePath			= 'lmfp';
	typeLAMorpheme				= 'lmfn';
	typeLAHomograph				= 'lmfh';

	keyAELAMorphemeBundle		= 'lmfb';
	keyAELAMorphemePath			= 'lmfp';
	keyAELAMorpheme				= 'lmfn';
	keyAELAHomograph			= 'lmfh';

	kLADefaultEdge				= 0;
	kLAFreeEdge					= 1;
	kLAIncompleteEdge			= 2;

	kAllMorphemes				= -1;

	kNoContext					= 0;


TYPE
	LAFeedbackType						= OptionBits;

CONST
	kLAAcceptedAsIs				= 0;
	kLAHomophoneSelected		= $01;
	kLALocalReanalysis			= $02;
	kLATransLiterate			= $04;

{
	Error Value
}
	laEngineNotFoundErr			= -7000;						{  can't find the engine }
	laPropertyErr				= -7001;						{  Error in properties }
	laPropertyNotFoundErr		= -7002;						{  can't find the property }
	laPropertyIsReadOnlyErr		= -7003;						{  the property is read only }
	laPropertyUnknownErr		= -7004;						{  the property is unknown to this environment }
	laPropertyValueErr			= -7005;						{  Invalid property value }
	laDictionaryTooManyErr		= -7006;						{  too many dictionaries }
	laDictionaryUnknownErr		= -7007;						{  can't use this dictionary with this environment }
	laDictionaryNotOpenedErr	= -7008;						{  the dictionary is not opened }
	laTextOverFlowErr			= -7009;						{  text is too long }
	laFailAnalysisErr			= -7010;						{  analysis failed }
	laNoMoreMorphemeErr			= -7011;						{  nothing to read }

{
	Handling Context
}
FUNCTION LAOpenContext(environ: LAEnvironmentLocaleObjectRef; VAR context: LAContextRef; VAR specificErr: OSStatus; VAR which: AERecord): OSStatus; C;
FUNCTION LACloseContext(context: LAContextRef): OSStatus; C;
{
	Handling Environment
}
FUNCTION LAGetEnvironmentProperty(environment: LAEnvironmentLocaleObjectRef; propertyKey: LAPropertyKey; desiredType: LAPropertyType; maxSize: ByteCount; VAR actualType: LAPropertyType; VAR actualSize: ByteCount; value: LogicalAddress): OSStatus; C;
FUNCTION LASetEnvironmentProperty(environment: LAEnvironmentLocaleObjectRef; propertyKey: LAPropertyKey; propertyType: LAPropertyType; valueSize: ByteCount; value: ConstLogicalAddress; VAR specificErr: OSStatus): OSStatus; C;
{
	Handling dictionries
}
FUNCTION LAOpenDictionary(environ: LAEnvironmentLocaleObjectRef; dictionaryID: DCMDictionaryID; VAR dictionaryProperty: AERecord): OSStatus; C;
FUNCTION LACloseDictionary(environ: LAEnvironmentLocaleObjectRef; dictionary: DCMDictionaryID): OSStatus; C;
FUNCTION LAListAvailableDictionary(environ: LAEnvironmentLocaleObjectRef; maxCount: ItemCount; VAR actualCount: ItemCount; VAR dictionaryList: DCMDictionaryID): OSStatus; C;
{
	Analyzing text
}
FUNCTION LAMorphemeAnalysis(context: LAContextRef; text: ConstTextObject; VAR leadingPath: LAMorphemePath; VAR trailingPath: LAMorphemePath; pathCount: ItemCount; VAR result: LAMorphemeBundle): OSStatus; C;
FUNCTION LAContinuousMorphemeAnalysis(context: LAContextRef; text: ConstTextObject; incrementalText: BOOLEAN; VAR leadingPath: LAMorphemePath; VAR trailingPath: LAMorphemePath; VAR modified: BOOLEAN): OSStatus; C;
FUNCTION LAGetMorphemes(context: LAContextRef; VAR result: LAMorphemePath): OSStatus; C;
FUNCTION LAShiftMorphemes(context: LAContextRef; morphemeCount: ItemCount; VAR path: LAMorphemePath; VAR byteCount: ByteCount): OSStatus; C;
FUNCTION LAResetAnalysis(context: LAContextRef): OSStatus; C;
FUNCTION LAGetAllHomographs(context: LAContextRef; {CONST}VAR path: LAMorphemePath; morphemeOffset: LAItemOffset; VAR morpheme: LAMorpheme): OSStatus; C;
FUNCTION LAGetRootForm(context: LAContextRef; {CONST}VAR path: LAMorphemePath; morphemeOffset: LAItemOffset; VAR rootForm: LAMorphemePath): OSStatus; C;
{
	Learning
}
FUNCTION LAFeedbackPath(context: LAContextRef; path: LAMorphemePath; startingPosition: LAItemOffset; morphemeCount: ItemCount; VAR feedbackType: LAFeedbackType; confirmed: BOOLEAN): OSStatus; C;
{
	TextObject interface
}
FUNCTION LAAnnotateTextObjectWithMorpheme(analysisClass: Str255; tagCount: ItemCount; VAR tags: DCMFieldTag; text: TextObject): OSStatus; C;
{$ENDC}
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := LanguageAnalysisIncludes}

{$ENDC} {__LANGUAGEANALYSIS__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
