{
 	File:		NumberFormatting.p
 
 	Version:	Technology:	8.0
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT NumberFormatting;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __NUMBERFORMATTING__}
{$SETC __NUMBERFORMATTING__ := 1}

{$I+}
{$SETC NumberFormattingIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __CONDITIONALMACROS__}
{$I ConditionalMacros.p}
{$ENDC}
{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}
{$IFC FOR_SYSTEM8_PREEMPTIVE }
{$IFC UNDEFINED __TEXTOBJECTS__}
{$I TextObjects.p}
{$ENDC}
{$IFC UNDEFINED __TEXTCOMMON__}
{$I TextCommon.p}
{$ENDC}
{$IFC UNDEFINED __LOCALEOBJECTS__}
{$I LocaleObjects.p}
{$ENDC}
{$IFC UNDEFINED __TEXTPARSER__}
{$I TextParser.p}
{$ENDC}
{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_COOPERATIVE }
{$IFC UNDEFINED __INTLRESOURCES__}
{$I IntlResources.p}
{$ENDC}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{

	Here are the current System 7 routine names and the translations to the older forms.
	Please use the newer forms in all new code and migrate the older names out of existing
	code as maintainance permits.
	
	New Name					Old Name(s)
	
	ExtendedToString			FormatX2Str
	FormatRecToString			Format2Str
	NumToString				
	StringToExtended			FormatStr2X
	StringToFormatRec			Str2Format
	StringToNum				

}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_PREEMPTIVE }

TYPE
	NumFormatStringPtr = ^NumFormatString;
	NumFormatString = PACKED RECORD
		fLength:				UInt8;
		fVersion:				UInt8;
		data:					PACKED ARRAY [0..253] OF CHAR;			{  private data  }
	END;

	NumFormatStringRec					= NumFormatString;
	NumFormatStringRecPtr 				= ^NumFormatStringRec;
{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_COOPERATIVE }

TYPE
	FormatStatus						= INTEGER;

CONST
	fVNumber					= 0;							{  first version of NumFormatString  }


TYPE
	FormatClass							= SInt8;

CONST
	fPositive					= 0;
	fNegative					= 1;
	fZero						= 2;


TYPE
	FormatResultType					= SInt8;

CONST
	fFormatOK					= 0;
	fBestGuess					= 1;
	fOutOfSynch					= 2;
	fSpuriousChars				= 3;
	fMissingDelimiter			= 4;
	fExtraDecimal				= 5;
	fMissingLiteral				= 6;
	fExtraExp					= 7;
	fFormatOverflow				= 8;
	fFormStrIsNAN				= 9;
	fBadPartsTable				= 10;
	fExtraPercent				= 11;
	fExtraSeparator				= 12;
	fEmptyFormatString			= 13;


TYPE
	FVectorPtr = ^FVector;
	FVector = RECORD
		start:					INTEGER;
		length:					INTEGER;
	END;

{  index by [fPositive..fZero]  }
	TripleInt							= ARRAY [0..2] OF FVector;
{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_PREEMPTIVE }
PROCEDURE StringToNum(theString: Str255; VAR theNum: LONGINT);
PROCEDURE NumToString(theNum: LONGINT; VAR theString: Str255);
{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_COOPERATIVE }
FUNCTION ExtendedToString(VAR x: extended80; {CONST}VAR myCanonical: NumFormatString; {CONST}VAR partsTable: NumberParts; VAR outString: Str255): FormatStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8210, $FFE8, $A8B5;
	{$ENDC}
FUNCTION StringToExtended(source: Str255; {CONST}VAR myCanonical: NumFormatString; {CONST}VAR partsTable: NumberParts; VAR x: extended80): FormatStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8210, $FFE6, $A8B5;
	{$ENDC}
FUNCTION StringToFormatRec(inString: Str255; {CONST}VAR partsTable: NumberParts; VAR outString: NumFormatString): FormatStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $820C, $FFEC, $A8B5;
	{$ENDC}
FUNCTION FormatRecToString({CONST}VAR myCanonical: NumFormatString; {CONST}VAR partsTable: NumberParts; VAR outString: Str255; VAR positions: TripleInt): FormatStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8210, $FFEA, $A8B5;
	{$ENDC}
{$ENDC}
{$IFC OLDROUTINENAMES }
{$IFC FOR_SYSTEM7_AND_SYSTEM8_DEPRECATED }
{$ENDC}
{  FOR_SYSTEM7_AND_SYSTEM8_DEPRECATED }
{$ENDC}
{  OLDROUTINENAMES }
{$IFC FOR_SYSTEM8_PREEMPTIVE }

TYPE
	LocaleNumberFormatterObjectRef		= LocaleObjectRef;
	NumberFormatterOptionBits			= OptionBits;
	NumberFormatterTokenID				= UInt32;
	FIndexVectorPtr = ^FIndexVector;
	FIndexVector = RECORD
		startIndex:				TextObjectIndex;
		endIndex:				TextObjectIndex;
	END;

{  index by [fPositive..fZero]  }
	TripleIndex							= ARRAY [0..2] OF FIndexVector;

CONST
																{ NumberFormatterOptionBits }
	kDontUseThousandSeparatorBit = 0;
	kIsScientificFormatBit		= 1;
	kIsPercentageFormatBit		= 2;
	kIsCurrencyFormatBit		= 3;
	kIsFractionCurrencyFormatBit = 4;
	kIsLongFormCurrencyFormatBit = 5;
	kOmitDecimalPointInCurrencyFormatBit = 6;
	kUseAsciiDigitBit			= 7;
	kUseNegativePosfixPrefixBit	= 8;

																{ NumberFormatterOptionBits }
	kStandardFormatMask			= 0;
	kDontUseThousandSeparatorMask = $00000001;
	kIsScientificFormatMask		= $00000002;
	kIsPercentageFormatMask		= $00000004;
	kIsCurrencyFormatMask		= $00000008;
	kIsFractionCurrencyFormatMask = $00000010;
	kIsLongFormCurrencyFormatMask = $00000020;
	kOmitDecimalPointInCurrencyFormatMask = $00000040;
	kUseAsciiDigitMask			= $00000080;
	kUseNegativePosfixPrefixMask = $00000100;

FUNCTION GetNumberFormatterObjectFromRef(locale: LocaleRef; VAR numberFormatterObject: LocaleNumberFormatterObjectRef): OSStatus; C;
FUNCTION GetNumberFormatterObjectFromID(localeID: LocaleIdentifier; VAR numberFormatterObject: LocaleNumberFormatterObjectRef): OSStatus; C;
FUNCTION GetCurrentNumberFormatterObject(VAR numberFormatterObject: LocaleNumberFormatterObjectRef): OSStatus; C;
FUNCTION GetNumberFormatterObjectInfo(numberFormatterObject: LocaleNumberFormatterObjectRef; VAR theEncoding: TextEncoding; VAR theLocaleIdentifier: LocaleIdentifier): OSStatus; C;
FUNCTION ConvertUInt32ToTextObject(theUInt32: UInt32; numberFormatterObject: LocaleNumberFormatterObjectRef; options: NumberFormatterOptionBits; theTextObject: TextObject; startReplaceIndex: TextObjectIndex; endReplaceIndex: TextObjectIndex): OSStatus; C;
FUNCTION ConvertSInt32ToTextObject(theSInt32: SInt32; numberFormatterObject: LocaleNumberFormatterObjectRef; options: NumberFormatterOptionBits; theTextObject: TextObject; startReplaceIndex: TextObjectIndex; endReplaceIndex: TextObjectIndex): OSStatus; C;
FUNCTION ConvertUInt64ToTextObject(theUInt64: UInt64; numberFormatterObject: LocaleNumberFormatterObjectRef; options: NumberFormatterOptionBits; theTextObject: TextObject; startReplaceIndex: TextObjectIndex; endReplaceIndex: TextObjectIndex): OSStatus; C;
FUNCTION ConvertSInt64ToTextObject(theSInt64: SInt64; numberFormatterObject: LocaleNumberFormatterObjectRef; options: NumberFormatterOptionBits; theTextObject: TextObject; startReplaceIndex: TextObjectIndex; endReplaceIndex: TextObjectIndex): OSStatus; C;
FUNCTION ConvertDoubleToTextObject(theDouble: Double; numberFormatterObject: LocaleNumberFormatterObjectRef; options: NumberFormatterOptionBits; precision: SInt8; theTextObj: TextObject; startReplaceIndex: TextObjectIndex; endReplaceIndex: TextObjectIndex): OSStatus; C;
FUNCTION ConvertTextObjectToUInt32(textObject: ConstTextObject; numberFormatterObject: LocaleNumberFormatterObjectRef; options: NumberFormatterOptionBits; startIndex: TextObjectIndex; endIndex: TextObjectIndex; VAR theUInt32: UInt32): OSStatus; C;
FUNCTION ConvertTextObjectToSInt32(textObject: ConstTextObject; numberFormatterObject: LocaleNumberFormatterObjectRef; options: NumberFormatterOptionBits; startIndex: TextObjectIndex; endIndex: TextObjectIndex; VAR theSInt32: SInt32): OSStatus; C;
FUNCTION ConvertTextObjectToUInt64(textObject: ConstTextObject; numberFormatterObject: LocaleNumberFormatterObjectRef; options: NumberFormatterOptionBits; startIndex: TextObjectIndex; endIndex: TextObjectIndex; VAR theUInt64: UInt64): OSStatus; C;
FUNCTION ConvertTextObjectToSInt64(textObject: ConstTextObject; numberFormatterObject: LocaleNumberFormatterObjectRef; options: NumberFormatterOptionBits; startIndex: TextObjectIndex; endIndex: TextObjectIndex; VAR theSInt64: SInt64): OSStatus; C;
FUNCTION ConvertTextObjectToDouble(textObject: ConstTextObject; localeObjectRef: LocaleNumberFormatterObjectRef; startIndex: TextObjectIndex; endIndex: TextObjectIndex; VAR theDouble: Double): OSStatus; C;
FUNCTION FormattedTextObjectToDouble(textObject: ConstTextObject; ref: LocaleNumberFormatterObjectRef; startIndex: TextObjectIndex; endIndex: TextObjectIndex; {CONST}VAR myCanonical: NumFormatString; {CONST}VAR num: Double): OSStatus; C;
FUNCTION DoubleToFormattedTextObject(VAR num: Double; ref: LocaleNumberFormatterObjectRef; {CONST}VAR myCanonical: NumFormatString; outTextObject: TextObject): OSStatus; C;
FUNCTION TextObjectToFormatRec(textObject: ConstTextObject; ref: LocaleNumberFormatterObjectRef; startIndex: TextObjectIndex; endIndex: TextObjectIndex; VAR outString: NumFormatString): OSStatus; C;
FUNCTION FormatRecToTextObject({CONST}VAR myCanonical: NumFormatString; ref: LocaleNumberFormatterObjectRef; outTextObject: TextObject; VAR positions: TripleIndex): OSStatus; C;

CONST
																{  NumberFormatterTokenID }
	kNumFmtCharLeftQuote		= 0;							{ (begin literal) }
	kNumFmtCharRightQuote		= 1;							{ (end literal) }
	kNumFmtCharLeadPlacer		= 2;							{  (^ in U.S) }
	kNumFmtCharLeader			= 3;							{ (non-breakable space in U.S) }
	kNumFmtCharNonLeader		= 4;							{ (# sign in U.S) }
	kNumFmtCharZeroLead			= 5;							{ (digit 0 in U.S) }
	kNumFmtCharCurrencyPlacer	= 6;							{  ($ in U.S) }
	kNumFmtCharPercent			= 7;							{  (%)  }
	kNumFmtCharPlusSign			= 8;							{  (+) }
	kNumFmtCharMinusSign		= 9;							{  (-)  }
	kNumFmtCharThousandSep		= 10;							{  (,)  }
	kNumFmtCharFormatSeparator	= 11;							{  (;)  }
	kNumFmtCharEscape			= 12;							{   (\)  }
	kNumFmtCharDecPoint			= 13;							{  (.)  }
	kNumFmtTextpePlus			= 14;							{  (E+)  }
	kNumFmtTextpeMinus			= 15;							{  (E-)  }
	kNumFmtTextMinusPlus		= 16;							{  (E)  }
	kNumFmtTextFirstRangeCurrencyForm = 17;						{  (Dollar)  }
	kNumFmtTextSecondRangeCurrencyForm = 18;					{  (Dollar(s))  }
	kNumFmtTextPluralCurrency	= 19;							{  (Dollar(s))  }
	kNumFmtTextfractionCurrency	= 20;							{  (cents))  }
	kNumFmtTextCurrencyAbbreviated = 21;						{  ($)  }
	kNumFmtTextfractionCurrencyAbbreviated = 22;				{  (Ԣ)  }
	kNumFmtTextNegativePrefix	= 23;							{  (()  }
	kNumFmtTextNegativePostfix	= 24;							{  ())  }


TYPE
	CurrencyPosition					= UInt32;

CONST
																{ CurrencyPosition }
	kAtTheBeginning				= 0;
	kAtDecimalPointPosition		= 1;
	kAtTheEnd					= 2;

FUNCTION CreateCustomNumberFormatLocaleObject(numberFormatterObject: LocaleNumberFormatterObjectRef; VAR customNumberFormatterObject: LocaleNumberFormatterObjectRef): OSStatus; C;
FUNCTION DeleteCustomNumberFormatLocaleObject(customNumberFormatterObject: LocaleNumberFormatterObjectRef): OSStatus; C;
FUNCTION SetNumFmtTokenToParserToken(customNumberFormatterObject: LocaleNumberFormatterObjectRef; tokenID: NumberFormatterTokenID; theToken: BasicToken): OSStatus; C;
FUNCTION GetParserTokenFromNumFmtToken(customNumberFormatterObject: LocaleNumberFormatterObjectRef; tokenID: NumberFormatterTokenID; VAR theToken: BasicToken): OSStatus; C;
FUNCTION GetNumberFormatterTextFromToken(customNumberFormatterObject: LocaleNumberFormatterObjectRef; tokenID: NumberFormatterTokenID; theTextObject: TextObject): OSStatus; C;
FUNCTION SetNumFmtTokenToText(customNumberFormatterObject: LocaleNumberFormatterObjectRef; tokenID: NumberFormatterTokenID; theTextObject: ConstTextObject): OSStatus; C;
FUNCTION GetLocaleLongCurrencyPosition(customNumberFormatterObject: LocaleNumberFormatterObjectRef; VAR position: CurrencyPosition): OSStatus; C;
FUNCTION SetLocaleLongCurrencyPosition(customNumberFormatterObject: LocaleNumberFormatterObjectRef; position: CurrencyPosition): OSStatus; C;
FUNCTION GetLocaleAbbrevCurrencyPosition(customNumberFormatterObject: LocaleNumberFormatterObjectRef; VAR position: CurrencyPosition): OSStatus; C;
FUNCTION SetLocaleAbbrevCurrencyPosition(customNumberFormatterObject: LocaleNumberFormatterObjectRef; position: CurrencyPosition): OSStatus; C;
FUNCTION GetLocaleFirstRangeCurrency(customNumberFormatterObject: LocaleNumberFormatterObjectRef; VAR maxValueInRange: UInt32): OSStatus; C;
FUNCTION SetLocaleFirstRangeCurrency(customNumberFormatterObject: LocaleNumberFormatterObjectRef; maxValueInRange: UInt32): OSStatus; C;
FUNCTION GetLocaleSecondRangeCurrency(customNumberFormatterObject: LocaleNumberFormatterObjectRef; VAR maxValueInRange: UInt32): OSStatus; C;
FUNCTION SetLocaleSecondRangeCurrency(customNumberFormatterObject: LocaleNumberFormatterObjectRef; maxValueInRange: UInt32): OSStatus; C;
FUNCTION GetLocaleDigitText(customNumberFormatterObject: LocaleNumberFormatterObjectRef; theDigit: ByteParameter; theTextObject: TextObject): OSStatus; C;
FUNCTION SetLocaleDigitText(customNumberFormatterObject: LocaleNumberFormatterObjectRef; theDigit: ByteParameter; theTextObject: TextObject): OSStatus; C;
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := NumberFormattingIncludes}

{$ENDC} {__NUMBERFORMATTING__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
