{
 	File:		PointingPlugin.p
 
 	Contains:	Interface for Pointer Family Plugins
 
 	Version:	Technology:	Copland
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT PointingPlugin;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __POINTINGPLUGIN__}
{$SETC __POINTINGPLUGIN__ := 1}

{$I+}
{$SETC PointingPluginIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __NAMEREGISTRY__}
{$I NameRegistry.p}
{$ENDC}
{$IFC UNDEFINED __POINTING__}
{$I Pointing.p}
{$ENDC}
{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{$IFC FOR_SYSTEM8_PREEMPTIVE }
{ *************** Calls Implemented By Plugins *************** }

TYPE
	PTPluginValidateHardwarePtr = ProcPtr;  { FUNCTION PTPluginValidateHardwarePtr(VAR device: RegEntryRef; VAR isMyDevice: BOOLEAN): OSStatus; C; }

	PTPluginInitializePtr = ProcPtr;  { FUNCTION PTPluginInitializePtr(VAR mouseRegistryEntryPtr: RegEntryRef; VAR mouseCapabilities: PTDeviceCapabilities; VAR mouseIdentification: PTDeviceIdentifier): OSStatus; C; }

	PTPluginTerminatePtr = ProcPtr;  { FUNCTION PTPluginTerminatePtr: OSStatus; C; }

	PTPluginStartIOPtr = ProcPtr;  { FUNCTION PTPluginStartIOPtr: OSStatus; C; }

	PTPluginStopIOPtr = ProcPtr;  { FUNCTION PTPluginStopIOPtr: OSStatus; C; }

	PTPluginGetNextDataPtr = ProcPtr;  { FUNCTION PTPluginGetNextDataPtr(VAR theMouseData: PTData): OSStatus; C; }

	PTPluginGetDeviceModesPtr = ProcPtr;  { FUNCTION PTPluginGetDeviceModesPtr(offset: ByteCount; numBytes: ByteCount; VAR modes: PTDeviceModes): OSStatus; C; }

	PTPluginSetDeviceModesPtr = ProcPtr;  { FUNCTION PTPluginSetDeviceModesPtr(offset: ByteCount; numBytes: ByteCount; VAR modes: PTDeviceModes): OSStatus; C; }


CONST
	kCoplandPTPluginVersion		= $00000001;


TYPE
	PTPluginHeaderPtr = ^PTPluginHeader;
	PTPluginHeader = RECORD
		version:				UInt32;									{  version of the plugin interface }
		reserved1:				UInt32;
		reserved2:				UInt32;
		reserved3:				UInt32;
	END;

	PTDeviceDispatchTablePtr = ^PTDeviceDispatchTable;
	PTDeviceDispatchTable = RECORD
		header:					PTPluginHeader;
		PTPluginValidateHardware: PTPluginValidateHardwarePtr;
		PTPluginInitialize:		PTPluginInitializePtr;
		PTPluginTerminate:		PTPluginTerminatePtr;
		PTPluginStartIO:		PTPluginStartIOPtr;
		PTPluginStopIO:			PTPluginStopIOPtr;
		PTPluginGetNextData:	PTPluginGetNextDataPtr;
		PTPluginGetDeviceModes:	PTPluginGetDeviceModesPtr;
		PTPluginSetDeviceModes:	PTPluginSetDeviceModesPtr;
	END;

{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := PointingPluginIncludes}

{$ENDC} {__POINTINGPLUGIN__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
