{
 	File:		Servers.p
 
 	Contains:	Server Interfaces.
 
 	Version:	Technology:	System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT Servers;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __SERVERS__}
{$SETC __SERVERS__ := 1}

{$I+}
{$SETC ServersIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __CODEFRAGMENTS__}
{$I CodeFragments.p}
{$ENDC}
{$IFC UNDEFINED __KERNEL__}
{$I Kernel.p}
{$ENDC}
{$IFC UNDEFINED __FILEMANAGERTYPES__}
{$I FileManagerTypes.p}
{$ENDC}

{$PUSH}
{$ALIGN POWER}
{$LibExport+}

{$IFC FOR_SYSTEM8_PREEMPTIVE }

TYPE
	ServerID = ^LONGINT;

CONST
	kCreateServerResType		= 'srvr';
	kCreateServerResID			= 0;


TYPE
	CreateServerOptions					= OptionBits;

CONST
	kServerReservesLowMem		= $00000001;					{  Cannot be enabled with kServerIsPrivileged }
	kServerIsPrivileged			= $00000002;					{  Cannot be enabled with kServerReservesLowMem }
	kCreateServerForLookup		= $00000004;
	kCreateServerAtStartup		= $00000008;


TYPE
	CreateServerDescriptorPtr = ^CreateServerDescriptor;
	CreateServerDescriptor = RECORD
		createOptions:			CreateServerOptions;
		name:					TaskName;
		taskOptions:			TaskOptions;
		stackSize:				ByteCount;
		serverName:				Str63;
	END;

	ServerMainEntry = ProcPtr;  { PROCEDURE ServerMainEntry(server: ServerID); C; }

FUNCTION CreateServer(fileRef_t: FSObjectRef; {CONST}VAR deathNotification_i: KernelNotification; timeout_i: Duration; VAR serverName_o: Str63; VAR server_o: ServerID; VAR refcon_o: UNIV Ptr): OSStatus; C;
FUNCTION CreateServerAsync(fileRef_t: FSObjectRef; {CONST}VAR deathNotification_i: KernelNotification; {CONST}VAR asyncNotification_i: KernelNotification; VAR serverName_o: Str63; VAR server_o: ServerID; VAR refcon_o: UNIV Ptr): OSStatus; C;
FUNCTION RegisterServer(fileRef_t: FSObjectRef; VAR serverName_o: Str63): OSStatus; C;
FUNCTION DeregisterServer(serverName_t: Str63): OSStatus; C;
FUNCTION LookupServer(serverName_t: Str63; timeout_i: Duration; VAR server_o: ServerID; VAR refcon_o: UNIV Ptr): OSStatus; C;
FUNCTION LookupServerAsync(serverName_t: Str63; {CONST}VAR asyncNotification_i: KernelNotification; VAR server_o: ServerID; VAR refcon_o: UNIV Ptr): OSStatus; C;
FUNCTION ServerCreated(server_t: ServerID; refcon_i: UNIV Ptr): OSStatus; C;
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := ServersIncludes}

{$ENDC} {__SERVERS__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
