{
 	File:		TextEncodingConverter.p
 
 	Contains:	Text Encoding Conversion Interfaces.
 
 	Version:	Technology:	System 7.1 through System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT TextEncodingConverter;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __TEXTENCODINGCONVERTER__}
{$SETC __TEXTENCODINGCONVERTER__ := 1}

{$I+}
{$SETC TextEncodingConverterIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}
{$IFC UNDEFINED __MIXEDMODE__}
{$I MixedMode.p}
{$ENDC}
{$IFC UNDEFINED __UNICODE__}
{$I Unicode.p}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{$IFC FOR_SYSTEM7_AND_SYSTEM8_PREEMPTIVE }
{  converter object reference  }

TYPE
	EncodingConverterRef = ^LONGINT;
{  character substitution  }
	CharSubstitutionPtr = ^CharSubstitution;
	CharSubstitution = RECORD
		originalChar:			UInt32;
		replacementChar:		UInt32;
	END;

	CharSubstitutionListPtr = ^CharSubstitutionList;
	CharSubstitutionList = RECORD
		numberOfSubstitutions:	ItemCount;
		list:					ARRAY [0..0] OF CharSubstitution;
	END;

{  invalid character lists  }
	InvalidCharRangePtr = ^InvalidCharRange;
	InvalidCharRange = RECORD
		firstCharInRange:		ByteOffset;
		lastCharInRange:		ByteOffset;
	END;

	InvalidCharRangeListPtr = ^InvalidCharRangeList;
	InvalidCharRangeList = RECORD
		numberOfRanges:			ItemCount;
		list:					ARRAY [0..0] OF InvalidCharRange;
	END;

{  encoding conversion options  }
	EncodingOptionsPtr = ^EncodingOptions;
	EncodingOptions = RECORD
		sourceflags:			UInt16;
		destflags:				UInt16;
		maxLineLength:			ItemCount;
	END;

{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_PREEMPTIVE }
{  return number of encodings types supported by user's configuraton of the encoding converter  }
FUNCTION CountAvailableTextEncodings(VAR numberOfMappings: ItemCount): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $021A, $ABCE;
	{$ENDC}
{  fill in an array of type TextEncoding passed in by the user with types of encodings the current configuration of the encoder can handle.  }
FUNCTION GetAvailableTextEncodings(VAR availableEncodings: TextEncoding; maxAvailableEncodings: ItemCount; VAR actualAvailableEncodings: ItemCount): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $061B, $ABCE;
	{$ENDC}
{  create a converter object with default conversion characteristics  }
FUNCTION NewEncodingConverter(VAR newEncodingConverter: EncodingConverterRef; inputEncoding: TextEncoding; outputEncoding: TextEncoding): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $061C, $ABCE;
	{$ENDC}
{  disose and encoding converter object  }
FUNCTION DisposeEncodingConverter(VAR newEncodingConverter: EncodingConverterRef): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $021D, $ABCE;
	{$ENDC}
{  manage substitution lists  }
FUNCTION SetConverterSubstitutionList(VAR encodingConverter: EncodingConverterRef; VAR charSubstitutionPtr: CharSubstitutionList): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $041E, $ABCE;
	{$ENDC}
FUNCTION GetConverterSubstitutionListCount(VAR encodingConverter: EncodingConverterRef; VAR count: ItemCount): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $041F, $ABCE;
	{$ENDC}
FUNCTION GetConverterSubstitutionList(VAR encodingConverter: EncodingConverterRef; VAR charSubstitutionPtr: CharSubstitutionList): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0220, $ABCE;
	{$ENDC}
{  manage invalid character lists  }
FUNCTION SetConverterInvalidCharRangeList(VAR encodingConverter: EncodingConverterRef; VAR invalidCharPtr: InvalidCharRangeList): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0421, $ABCE;
	{$ENDC}
FUNCTION GetConverterInvalidCharRangeListCount(VAR encodingConverter: EncodingConverterRef; VAR count: ItemCount): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0422, $ABCE;
	{$ENDC}
FUNCTION GetConverterInvalidCharRangeList(VAR encodingConverter: EncodingConverterRef; VAR invalidCharPtr: InvalidCharRangeList): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0423, $ABCE;
	{$ENDC}
FUNCTION ConvertTextEncoding(VAR encodingConverter: EncodingConverterRef; clearContext: BOOLEAN; VAR inputText: BytePtr; VAR inputLength: ByteCount; outputBuffer: BytePtr; outputBufferSize: ByteCount; VAR actualOutputLength: ByteCount): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $1024, $ABCE;
	{$ENDC}
FUNCTION ExamineTextEncoding(VAR inputText: BytePtr; VAR inputLength: ByteCount; VAR availableEncodings: TextEncoding; maxAvailableEncodings: ItemCount; VAR validEncoding: BOOLEAN): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0A25, $ABCE;
	{$ENDC}
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := TextEncodingConverterIncludes}

{$ENDC} {__TEXTENCODINGCONVERTER__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
