{
 	File:		TextEngineTypes.p
 
 	Version:	Technology:	System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT TextEngineTypes;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __TEXTENGINETYPES__}
{$SETC __TEXTENGINETYPES__ := 1}

{$I+}
{$SETC TextEngineTypesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __CONDITIONALMACROS__}
{$I ConditionalMacros.p}
{$ENDC}
{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{$IFC FOR_SYSTEM8_COOPERATIVE }

TYPE
	TSystemTextEngine = ^LONGINT;
	HIEditTextPanel = ^LONGINT;
	TSystemTextEnginePtr				= ^TSystemTextEngine;
	TextEngineID						= OSType;
	CharacterOffset						= UInt32;
	TextEngineOptions					= OptionBits;
	TextIterationtype					= OptionBits;
	TextSelectionType					= OSType;
	TextAttributeTag					= OSType;
	TextEngineFeature					= OSType;
	EditCommandID						= UInt32;
	TFeatureList						= ARRAY [0..0] OF TextEngineFeature;
	TextAlignment						= UInt16;
	TextFontFace						= OSType;
	TextEngineRef = ^LONGINT;
	TextDataStructureRef = ^LONGINT;
	TextAttributeIteratorRef = ^LONGINT;

CONST
																{ TextEngineID }
	kTextEditEngine				= 'tedt';

																{ TextEngineFeature }
	kMultiStyleFeature			= 'mlst';
	kTSM1_0AwareFeature			= 'tsm1';
	kTSM2_0AwareFeature			= 'tsm2';
	kMaskingModeFeature			= 'pswd';
	kTextSizeIsUInt32Feature	= 'tx32';
	kCoordinateSizeIsUInt32Feature = 'co32';
	kEmbeddableGraphicsFeature	= 'emgr';
	kEmbeddableSoundsFeature	= 'emsn';
	kEmbeddableMoviesFeature	= 'emmo';
	kEmbeddable3DGraphicsFeature = 'em3D';
	kHasCommandInterfaceObjectFeature = 'cmin';
	kGXBasedFeature				= 'gxba';
	kMultiLingualFeature		= 'mlng';
	kR2LSupportFeature			= 'r2ls';
	kVerticalTextSupportFeature	= 'vert';
	kAnnotationSupportFeature	= 'anot';
	kAETextSuiteSupportFeature	= 'aetx';
	kOpenDocSupportFeature		= 'odoc';

																{ TextEngineOptions option bits number }
	kMaskedTextBit				= 0;
	kReadOnlySelectableBit		= 1;
	kDontInstallEventHandlerBit	= 2;
	kDontUseOffscreenBit		= 3;

																{ Text engine option bits masks }
	kStandardOptions			= 0;
	kMaskedTextMask				= $01;
	kReadOnlySelectableMask		= $02;
	kDontInstallEventHandlerMask = $04;
	kDontUseOffscreenMask		= $08;

																{ TextAttributeTag attribute tags for styles }
	kEncodingAttribute			= 'encd';
	kFontAttribute				= 'font';
	kLanguageRegionAttribute	= 'lnrg';
	kHorizontalRunDirectionAttribute = 'hdir';					{ read only (cannot set it, deduced from encoding or font ??) }
	kVVerticalRunDirectionAttribute = 'vdir';
	kSizeAttribute				= 'size';
	kfaceAttribute				= 'face';						{ QD style byte }
	kColorAttribute				= 'colr';						{  tags for face }
	kPlainFaceAttribute			= 'plin';
	kBoldFaceAttribute			= 'bold';
	kItalicFaceAttribute		= 'ital';
	kStrikeThroughFaceAttribute	= 'stkt';
	kUnderlineFaceAttribute		= 'undl';
	kDoubleUnderlineFaceAttribute = 'dudl';
	kOutlinefaceAttribute		= 'outl';
	kShadowFaceAttribute		= 'shdw';
	kCondensedFaceAttribute		= 'cnds';
	kExtendedFaceAttribute		= 'extd';
	kSuperScriptFaceAttribute	= 'susc';
	kSubScriptFaceAttribute		= 'subs';

																{ TextIterationtype }
	kIterateOnCharacters		= $0001;
	kIterateOnWords				= $0002;
	kIterateOnLines				= $0004;
	kIterateOnParagraph			= $0008;

																{ Alignmnent }
	kTextAlignedWithDirection	= $0000;
	kTextAlignedRight			= $0002;
	kTextAlignedLeft			= $0004;
	kTextAlignedCenter			= $0008;

																{  EditCommandID }
	kNoCommand					= 0;
	kTypingCmd					= 1;
	kCutCmd						= 2;
	kCopyCmd					= 3;
	kPasteCmd					= 4;
	kClearCmd					= 5;
	kDropCmd					= 6;
	kAttributeChangeCmd			= 7;

	kSwitchFaceOption			= $0000;
	kAddFaceOption				= $0001;

	kTextAttrDontCare			= 0;

	kTextStartIndex				= 0;
	kTextEndIndex				= $FFFFFFFF;

	kTextUnbounded				= 0;
	kUseViewBounds				= -1;


TYPE
	MouseDownInTextTrackProcPtr = ProcPtr;  { FUNCTION MouseDownInTextTrack(VAR theTextInstance: TSystemTextEngine; hScroll: SInt32; vScroll: SInt32; userData: UNIV Ptr): OSStatus; C; }

	MouseDownInTextPanelTrackProcPtr = ProcPtr;  { FUNCTION MouseDownInTextPanelTrack(VAR theTextPanel: HIEditTextPanel; hScroll: SInt32; vScroll: SInt32; userData: UNIV Ptr): OSStatus; C; }

{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := TextEngineTypesIncludes}

{$ENDC} {__TEXTENGINETYPES__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
