{
 	File:		TextInputSystem.p
 
 	Contains:	The handling of text input user interface.
 
 	Version:	Technology:	System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT TextInputSystem;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __TEXTINPUTSYSTEM__}
{$SETC __TEXTINPUTSYSTEM__ := 1}

{$I+}
{$SETC TextInputSystemIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}
{$IFC UNDEFINED __TEXTCOMMON__}
{$I TextCommon.p}
{$ENDC}
{$IFC UNDEFINED __LOCALEOBJECTS__}
{$I LocaleObjects.p}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{$IFC FOR_SYSTEM8_COOPERATIVE }
{ ____________________________________________________________________________________ }
{

Routine:	GetCurrentTextInputLocaleIdentifier
			gets the LocaleIdentifier of the currently selected text input object.
Input:		NONE.
Output:		langRegionCode: the currently selected object.
OSStatus:	(no error, ?)
NOTE:		System8 only.

}
FUNCTION GetCurrentTextInputLocaleIdentifier(VAR langRegionCode: LocaleIdentifier): OSStatus; C;
{ ____________________________________________________________________________________ }
{

Routine:	GetCurrentTextInputRef
			gets the current text input object reference.
Input:		NONE.
Output:		textInputObject: the currently selected object.
OSStatus:	(no error, ?)
NOTE:		System8 only.
}
FUNCTION GetCurrentTextInputRef(VAR textInputObject: LocaleObjectRef): OSStatus; C;
{ ____________________________________________________________________________________ }
{

Routine:	SetCurrentTextInputLocaleIdentifier
			sets the current text input object according to the passed-in LocaleIdentifier.
Input:		textInputObject: the object selected by the client.
Output:		NONE.
OSStatus:	(no error, invalide object)
NOTE:		if the object is not shown, it will be displayed in the menu if the system supports
			this language/region/... locale.

}
FUNCTION SetCurrentTextInputLocaleIdentifier(langRegionCode: LocaleIdentifier): OSStatus; C;
{ ____________________________________________________________________________________ }
{

Routine:	SetCurrentTextInputRef
			sets the current text input object ref.
Input:		textInputObject: the object selected by the client.
Output:		NONE.
OSStatus:	(no error, invalide object)
NOTE:		if the object is not shown, it will be displayed in the menu if the system supports
			this language/region/... locale.
}
FUNCTION SetCurrentTextInputRef(textInputObject: LocaleObjectRef): OSStatus; C;
{
____________________________________________________________________________________
	routines for converting between a text input object ref and the new LocaleIdentifier
____________________________________________________________________________________
}
{

Routine:	GetLocaleIdentifierFromTextInputObjectRef
			returns the LocaleIdentifier textInputObject represents.
Input:		textInputObject:	the reference of text input object.
Output:		langRegionCode:		localeIdentifier that this objects is stamped with.
OSStatus:	(no error, ?)
NOTE:		System8 only.

}
FUNCTION GetLocaleIdentifierFromTextInputObjectRef(textInputObject: LocaleObjectRef; VAR langRegionCode: LocaleIdentifier): OSStatus; C;
{ ____________________________________________________________________________________ }
{

Routine:	GetTextInputObjectRefFromLocaleIdentifier
			gets the object ref last designated by the user as representing the lanaguag/region
			LocaleIdentifier (or simply returns the default one), otherwise it returns null.
Input:		langRegioncode:		value of LocaleIdentifier.
Output:		textInputObject:	best match returned object.
OSStatus:	(no error, ?)
NOTE:		System8 only.

}
FUNCTION GetTextInputObjectRefFromLocaleIdentifier(langRegionCode: LocaleIdentifier; VAR textInputObject: LocaleObjectRef): OSStatus; C;
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := TextInputSystemIncludes}

{$ENDC} {__TEXTINPUTSYSTEM__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
