{
 	File:		TextObjectImaging.p
 
 	Contains:	Text object Imaging Interfaces.
 
 	Version:	Technology:	System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT TextObjectImaging;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __TEXTOBJECTIMAGING__}
{$SETC __TEXTOBJECTIMAGING__ := 1}

{$I+}
{$SETC TextObjectImagingIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __CONDITIONALMACROS__}
{$I ConditionalMacros.p}
{$ENDC}
{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}
{$IFC UNDEFINED __TEXTOBJECTS__}
{$I TextObjects.p}
{$ENDC}
{$IFC UNDEFINED __QUICKDRAW__}
{$I Quickdraw.p}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{$IFC FOR_SYSTEM7_AND_SYSTEM8_COOPERATIVE }
{  An alias for OptionBits to make the intended usage in the prototypes easier to understand  }

TYPE
	TextObjectImagingOptions			= OptionBits;
{  Global direction choices  }
	TextObjectDirection					= UInt8;

CONST
	kTextObjSysDirection		= 0;
	kTextObjLeftToRight			= 1;
	kTextObjRightToLeft			= 2;

{  Imaging option bits  }
	kTextObjAlignmentOptionBits	= 0;
	kTextObjJustifyBit			= 2;
	kTextObjCondenseBit			= 3;
	kTextObjElisionBits			= 4;

{  Alignment options  }
	kTextObjAlignWithDirectionOpt = $00;
	kTextObjAlignLeftOpt		= $01;
	kTextObjAlignRightOpt		= $02;
	kTextObjAlignCenterOpt		= $03;

{  Justification options  }
	kTextObjDontJustifyOpt		= $00;
	kTextObjJustifyOpt			= $04;

{  Condensed font options  }
	kTextObjTryCondenseOpt		= $00;
	kTextObjDontCondenseOpt		= $08;

{  Elision options  }
	kTextObjElideMiddleOpt		= $00;
	kTextObjElideEndOpt			= $10;
	kTextObjElideBeginningOpt	= $20;
	kTextObjDontElideOpt		= $30;

FUNCTION DrawTextObject(textObject: ConstTextObject; startIndex: TextObjectIndex; endIndex: TextObjectIndex; grafPort: CGrafPtr; direction: ByteParameter; options: TextObjectImagingOptions): OSStatus; C;
FUNCTION ComputeTextObjectBounds(textObject: ConstTextObject; startIndex: TextObjectIndex; endIndex: TextObjectIndex; grafPort: CGrafPtr; direction: ByteParameter; fontSubstitutionHint: TextObjectImagingOptions; VAR width: Fixed; VAR lineHeight: Fixed; VAR ascent: Fixed): OSStatus; C;
FUNCTION FlowTextObjectOntoLine(textObject: ConstTextObject; startIndex: TextObjectIndex; endIndex: TextObjectIndex; grafPort: CGrafPtr; availableWidth: Fixed; direction: ByteParameter; alignAndFitOptions: TextObjectImagingOptions; VAR actualWidth: Fixed): OSStatus; C;
FUNCTION FlowTextObjectIntoBox(textObject: ConstTextObject; startIndex: TextObjectIndex; endIndex: TextObjectIndex; grafPort: CGrafPtr; {CONST}VAR box: Rect; direction: ByteParameter; alignAndJustOptions: TextObjectImagingOptions; VAR actualExtent: Fixed; VAR lineHeight: Fixed; VAR clipIndex: TextObjectIndex): OSStatus; C;
FUNCTION ComputeTextObjectBoxExtent(textObject: ConstTextObject; startIndex: TextObjectIndex; endIndex: TextObjectIndex; grafPort: CGrafPtr; {CONST}VAR box: Rect; direction: ByteParameter; alignAndJustOptions: TextObjectImagingOptions; VAR actualExtent: Fixed; VAR lineHeight: Fixed; VAR clipIndex: TextObjectIndex): OSStatus; C;
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := TextObjectImagingIncludes}

{$ENDC} {__TEXTOBJECTIMAGING__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
