{
 	File:		TextParser.p
 
 	Contains:	International Text Parser Interfaces.
 
 	Version:	Technology:	System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT TextParser;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __TEXTPARSER__}
{$SETC __TEXTPARSER__ := 1}

{$I+}
{$SETC TextParserIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __CONDITIONALMACROS__}
{$I ConditionalMacros.p}
{$ENDC}
{$IFC FOR_SYSTEM8_PREEMPTIVE }
{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}
{$IFC UNDEFINED __TEXTOBJECTS__}
{$I TextObjects.p}
{$ENDC}
{$IFC UNDEFINED __TEXTCOMMON__}
{$I TextCommon.p}
{$ENDC}
{$IFC UNDEFINED __LOCALEOBJECTS__}
{$I LocaleObjects.p}
{$ENDC}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{$IFC FOR_SYSTEM8_PREEMPTIVE }

TYPE
	TTextParseRef = ^LONGINT;
	ParsingToken						= UInt32;
	BasicToken							= ParsingToken;
	RangeToken							= ParsingToken;
	KeywordToken						= ParsingToken;
	MultiChoiceToken					= ParsingToken;
	ComposedToken						= ParsingToken;
{ defintions for the future }
	RegExpToken							= ParsingToken;
	GrammarRuleToken					= ParsingToken;
{ definition of Pointers to tokens }
	ParsingTokenPtr						= ^ParsingToken;
	BasicTokenPtr						= ParsingTokenPtr;
	RangeTokenPtr						= ParsingTokenPtr;
	KeywordTokenPtr						= ParsingTokenPtr;
	MultiChoiceTokenPtr					= ParsingTokenPtr;
	ComposedTokenPtr					= ParsingTokenPtr;
	ParsingOptionBits					= OptionBits;
	ParserLocaleObjectRef				= LocaleObjectRef;

CONST
																{ ParsingOptionBits }
	kParseMainTokenOptionBit	= 0;
	kIsAlphaNumericKeyWordOptionBit = 1;
	kIsCaseSensitiveParsingOptionBit = 2;
	kIsDiacreticSensitiveParsingOptionBit = 3;
	kParseTextEnclosedByLitearlDelimitersOptionBit = 4;
	kIsCommentsAllowedOptionBit	= 5;

																{ ParsingOptionMask }
	kStandardParsingOptionsMask	= 0;
	kParseMainTokenOptionMask	= $00000001;
	kIsAlphaNumericKeyWordOptionMask = $00000002;
	kIsCaseSensitiveParsingOptionMask = $00000004;
	kIsDiacreticSensitiveParsingOptionMask = $00000008;
	kParseTextEnclosedByLitearlDelimitersOptionMask = $00000010;
	kIsCommentsAllowedOptionMask = $00000020;

{  Basic Tokens definitions (try to match system 7 tokens when possible }
	kBasicTokenUnknown			= 0;							{ characters that don't have token definition }
	kBasicTokenEscape			= 10;							{ character escape (e.g. '\' in "\n", "\t") }
	kBasicTokenLeftParen		= 16;							{ open parenthesis }
	kBasicTokenRightParen		= 17;							{ close parenthesis }
	kBasicTokenLeftBracket		= 18;							{ open square bracket }
	kBasicTokenRightBracket		= 19;							{ close square bracket }
	kBasicTokenLeftCurly		= 20;
	kBasicTokenRightCurly		= 21;							{ close curly bracket }
	kBasicTokentokenLeftEnclose	= 22;							{ open guillemet }
	kBasicTokenRightEnclose		= 23;							{ close guillemet }
	kBasicTokenPlus				= 24;
	kBasicTokenMinus			= 25;
	kBasicTokenAsterisk			= 26;							{ times/multiply }
	kBasicTokenDivide			= 27;
	kBasicTokenPlusMinus		= 28;							{ plus or minus symbol }
	kBasicTokenSlash			= 29;
	kBasicTokenBackSlash		= 30;
	kBasicTokenLess				= 31;							{ less than symbol }
	kBasicTokenGreat			= 32;							{ greater than symbol }
	kBasicTokenEqual			= 33;
	kBasicTokenLessEqual1		= 35;							{ less than or equal, 1 character }
	kBasicTokenGreatEqual1		= 37;							{ greater than or equal, 1 character }
	kBasicTokenNotEqual			= 40;							{ not equal, 1 character }
	kBasicTokenExclam			= 43;							{ exclamation point }
	kBasicTokenTilde			= 44;							{ centered tilde }
	kBasicTokenComma			= 45;
	kBasicTokenPeriod			= 46;
	kBasicTokenLeft2Quote		= 47;							{ open double quote }
	kBasicTokenRight2Quote		= 48;							{ close double quote }
	kBasicTokenLeft1Quote		= 49;							{ open single quote }
	kBasicTokenRight1Quote		= 50;							{ close single quote }
	kBasicToken2Quote			= 51;							{ double quote }
	kBasicToken1Quote			= 52;							{ single quote }
	kBasicTokenSemicolon		= 53;
	kBasicTokenPercent			= 54;
	kBasicTokenCaret			= 55;
	kBasicTokenUnderline		= 56;
	kBasicTokenAmpersand		= 57;
	kBasicTokenAtSign			= 58;
	kBasicTokenBar				= 59;							{ vertical bar }
	kBasicTokenQuestion			= 60;
	kBasicTokenPi				= 61;							{ lower-case pi }
	kBasicTokenRoot				= 62;							{ square root symbol }
	kBasicTokenSigma			= 63;							{ capital sigma }
	kBasicTokenIntegral			= 64;							{ integral sign }
	kBasicTokenMicro			= 65;
	kBasicTokenCapPi			= 66;							{ capital pi }
	kBasicTokenInfinity			= 67;
	kBasicTokenColon			= 68;
	kBasicTokenHash				= 69;							{ e.g. # }
	kBasicTokenDollar			= 70;
	kBasicTokenNoBreakSpace		= 71;							{ non-breaking space }
	kBasicTokenFraction			= 72;
	kBasicTokenIntlCurrency		= 73;
	kBasicTokenLeftSingGuillemet = 74;
	kBasicTokenRightSingGuillemet = 75;
	kBasicTokenPerThousand		= 76;
	kBasicTokenEllipsis			= 77;
	kBasicTokenCenterDot		= 78;
	kBasicTokenSpace			= 128;
	kBasicTokenPasswordChar		= 129;

																{ predefined composed tokens }
	kComposedTokenLessEqual2	= 16383;						{ less than or equal, 2 characters (e.g. <=) }
	kComposedTokenEqual2		= 16384;						{ greater than or equal, 2 characters (e.g. >=) }
	kComposedToken2Equal		= 16385;						{ double equal (e.g. ==) }
	kComposedTokenColonEqual	= 16386;						{ colon equal }
	kComposedTokenLessGreat		= 16387;						{ less/greater, Pascal not equal (e.g. <>) }
	kComposedTokenExclamEqual	= 16388;						{ exclamation equal, C not equal (e.g. !=) }
	kComposedTokenNewLine		= 16389;						{ composed may be more than one (10,13) }

																{ predefined multiple choice tokens }
	kChoiceTokenWhite			= 8192;							{ white space (CR,LF,space, non break space) }
	kChoiceTokenLeftLit			= 8193;							{ literal begin , can be one or more }
	kChoiceTokenRightLit		= 8194;							{ literal end, can be one or more }
	kChoiceTokenAlpha			= 8195;							{ alphabetic char }
	kChoiceTokenNumeric			= 8196;							{ numeric char }
	kChoiceTokenPunctuationChar	= 8197;							{ punctuation char }
	kChoiceTokenRightComment	= 8198;							{  can be one or more }
	kChoiceTokenLeftComment		= 8199;							{  can be one or more }

																{ predefined token classes (not overridable for 8.0) mapped to regular expression tokens }
	kTokenClassIdentifier		= 32768;						{   alphabetic or alphanumeric entities }
	kTokenClassComment			= 32769;						{ 	anything inside comment delimiters  }
	kTokenClassliteral			= 32770;						{ 	anything inside literal delimiters  }
	kTokenClassIntegerNumber	= 32771;						{  text is numeric presentation (integers) }
	kTokenClassFloatingNumber	= 32772;						{ text is numeric presentation (float) }


TYPE
	CharacterRangePtr = ^CharacterRange;
	CharacterRange = RECORD
																		{  structure defining a range of char }
		theCharRangeBegin:		UInt32;
		theCharRangeEnd:		UInt32;
	END;

{ ============================================================locale object parser APIs==================================================== }
FUNCTION GetParserObjectByLocaleID(theLocaleIdentifier: LocaleIdentifier; theEncoding: TextEncoding; VAR theParserObject: ParserLocaleObjectRef): OSStatus; C;
FUNCTION GetParserObjectByLocaleRef(locale: LocaleRef; theEncoding: TextEncoding; VAR theParserObject: ParserLocaleObjectRef): OSStatus; C;
FUNCTION GetCurrentParserObject(VAR theParserObject: ParserLocaleObjectRef): OSStatus; C;
FUNCTION GetParserObjectInfo(theParserObject: ParserLocaleObjectRef; VAR theEncoding: TextEncoding; VAR theLocaleIdentifier: LocaleIdentifier): OSStatus; C;
{ ======================================================Iterator creation/modifcation========================================================== }
FUNCTION CreateLexicalIterator(localeParserRef: ParserLocaleObjectRef; theTextObject: TextObject; startIndex: TextObjectIndex; endIndex: TextObjectIndex; theParsingOptions: ParsingOptionBits; VAR theParserRef: TTextParseRef): OSStatus; C;
FUNCTION LexicalIteratorGetNextToken(theParser: TTextParseRef; VAR theCurrentToken: ParsingToken; VAR startIndex: TextObjectIndex; VAR endIndex: TextObjectIndex): OSStatus; C;
FUNCTION LexicalIteratorSetCommentDelimiters(refLexicalIterator: TTextParseRef; tokenLeftDel: ParsingToken; tokenRightDel: ParsingToken): OSStatus; C;
FUNCTION LexicalIteratorReset(refLexicalIterator: TTextParseRef): OSStatus; C;
FUNCTION LexicalIteratorSetText(refLexicalIterator: TTextParseRef; theTextObject: TextObject; startIndex: TextObjectIndex; endIndex: TextObjectIndex): OSStatus; C;
FUNCTION LexicalIteratorSetTokenToMatch(refLexicalIterator: TTextParseRef; theToken: ComposedToken): OSStatus; C;
{ ======================================================Tokens Get/Set APIs ========================================================== }
FUNCTION LexicalIteratorDefineBasicToken(refLexicalIterator: TTextParseRef; theChar: UInt32; theToken: BasicToken): OSStatus; C;
FUNCTION GetUniqueBasicToken(refLexicalIterator: TTextParseRef; VAR theToken: BasicToken): OSStatus; C;
FUNCTION LexicalIteratorDefineKeywordToken(refLexicalIterator: TTextParseRef; theText: TextObject; theStart: TextObjectIndex; theEnd: TextObjectIndex; theToken: KeywordToken): OSStatus; C;
FUNCTION GetUniqueKeywordToken(refLexicalIterator: TTextParseRef; VAR theToken: KeywordToken): OSStatus; C;
FUNCTION LexicalIteratorDefineRangeToken(refLexicalIterator: TTextParseRef; rangeBeginChar: UInt32; rangeEndChar: UInt32; theToken: RangeToken): OSStatus; C;
FUNCTION GetUniqueRangeToken(refLexicalIterator: TTextParseRef; VAR theToken: RangeToken): OSStatus; C;
FUNCTION LexicalIteratorDefineMultiChoiceToken(refLexicalIterator: TTextParseRef; nChoices: ItemCount; VAR theChoices: ParsingToken; VAR theToken: MultiChoiceToken): OSStatus; C;
FUNCTION GetUniqueMultiChoiceToken(refLexicalIterator: TTextParseRef; VAR theToken: MultiChoiceToken): OSStatus; C;
FUNCTION LexicalIteratorDefineComposedToken(refLexicalIterator: TTextParseRef; nChoices: ItemCount; VAR theChoices: ParsingToken; VAR theToken: ComposedToken): OSStatus; C;
FUNCTION GetUniqueComposedToken(refLexicalIterator: TTextParseRef; VAR theToken: ComposedToken): OSStatus; C;
FUNCTION GetTextFromToken(refLexicalIterator: TTextParseRef; theToken: ParsingToken; TheText: TextObject): OSStatus; C;
FUNCTION GetLocaleTextFromToken(localeParserRef: ParserLocaleObjectRef; theToken: ParsingToken; TheText: TextObject): OSStatus; C;
FUNCTION GetRangeToken(refLexicalIterator: TTextParseRef; theToken: RangeToken; VAR beginRangeChar: UInt32; VAR endRangeChar: UInt32): OSStatus; C;
FUNCTION GetLocaleRangeToken(localeParserRef: ParserLocaleObjectRef; theToken: RangeToken; VAR beginRangeChar: UInt32; VAR endRangeChar: UInt32): OSStatus; C;
FUNCTION GetCountTokenChoices(refLexicalIterator: TTextParseRef; theToken: MultiChoiceToken; VAR nChoices: ItemCount): OSStatus; C;
FUNCTION GetLocaleCountTokenChoices(localeParserRef: ParserLocaleObjectRef; theToken: MultiChoiceToken; VAR nChoices: ItemCount): OSStatus; C;
FUNCTION GetMultiChoiceToken(refLexicalIterator: TTextParseRef; theToken: MultiChoiceToken; VAR theChoices: ParsingToken): OSStatus; C;
FUNCTION GetLocaleMultiChoiceToken(localeParserRef: ParserLocaleObjectRef; theToken: MultiChoiceToken; VAR theChoices: ParsingToken): OSStatus; C;
FUNCTION GetCountTokenComposition(refLexicalIterator: TTextParseRef; theToken: ComposedToken; VAR nChoices: ItemCount): OSStatus; C;
FUNCTION GetLocaleCountTokenComposition(localeParserRef: ParserLocaleObjectRef; theToken: ComposedToken; VAR nChoices: ItemCount): OSStatus; C;
FUNCTION GetComposedToken(refLexicalIterator: TTextParseRef; theToken: ComposedToken; VAR theComposition: ParsingToken): OSStatus; C;
FUNCTION GetLocaleComposedToken(localeParserRef: ParserLocaleObjectRef; theToken: ComposedToken; VAR theChoices: ParsingToken): OSStatus; C;
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := TextParserIncludes}

{$ENDC} {__TEXTPARSER__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
