{
 	File:		TimeObjects.p
 
 	Contains:	International Time Interfaces.
 
 	Version:	Technology:	System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT TimeObjects;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __TIMEOBJECTS__}
{$SETC __TIMEOBJECTS__ := 1}

{$I+}
{$SETC TimeObjectsIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __CONDITIONALMACROS__}
{$I ConditionalMacros.p}
{$ENDC}
{$IFC UNDEFINED __KERNEL__}
{$I Kernel.p}
{$ENDC}
{$IFC UNDEFINED __LOCALEOBJECTS__}
{$I LocaleObjects.p}
{$ENDC}
{$IFC UNDEFINED __OSUTILS__}
{$I OSUtils.p}
{$ENDC}
{$IFC UNDEFINED __TEXTOBJECTS__}
{$I TextObjects.p}
{$ENDC}
{$IFC UNDEFINED __TIMING__}
{$I Timing.p}
{$ENDC}
{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 ++																				++
 ++						Type definitions for Modern APIs						++
 ++																				++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
}
{$IFC FOR_SYSTEM8_PREEMPTIVE }
{  Precision of TimeObject  }

TYPE
	TimeObjectPrecision					= UInt8;

CONST
	kTONanosecondsPrecision		= $00;
	kTOMicrosecondsPrecision	= $01;
	kTOMillisecondsPrecision	= $02;
	kTOSecondsPrecision			= $03;
	kTOMinutesPrecision			= $04;
	kTOHoursPrecision			= $05;
	kTODaysPrecision			= $06;

{  Maximun Time Object Precision  }
	kTOMaxPrecision				= $06;


TYPE
	TimeObjectNotificationRef			= UInt32;
	MachineLocationRecordPtr = ^MachineLocationRecord;
	MachineLocationRecord = RECORD
		longitude:				Fixed;
		latitude:				Fixed;
		daylightSavingsDelta:	TimeObjectInterval;
		utcDelta:				TimeObjectInterval;
	END;

	ConstMachineLocationRecordPtr		= ^MachineLocationRecord;
	UTCTimeRecordPtr = ^UTCTimeRecord;
	UTCTimeRecord = RECORD
		era:					UInt16;									{  [0 = B.C.E., 1 = C.E. ] }
		year:					UInt16;									{  [0, 65535] }
		month:					UInt16;									{  [0,12] }
		day:					UInt16;									{  [0,32] }
		hour:					UInt16;									{  [0,23] }
		minute:					UInt16;									{  [0,60] }
		seconds:				UInt16;									{  [0,60] }
		milliseconds:			UInt16;									{  [0,1e3) }
		microseconds:			UInt32;									{  [0,1e6) }
		nanoseconds:			UInt32;									{  [0,1e9) }
		precision:				SInt8;
	END;

	ConstUTCTimeRecordPtr				= ^UTCTimeRecord;
	UTCTimeIntervalRecordPtr = ^UTCTimeIntervalRecord;
	UTCTimeIntervalRecord = RECORD
		day:					SInt32;
		hour:					SInt32;
		minute:					SInt32;
		seconds:				SInt32;
		milliseconds:			SInt32;
		microseconds:			SInt32;
		nanoseconds:			SInt32;
		precision:				SInt8;
	END;

	ConstUTCTimeIntervalRecordPtr		= ^UTCTimeIntervalRecord;
	TimeObjectConversionType			= UInt32;

CONST
	kUseRomanNumbers			= 0;
	kUseNativeNumbers			= 1;


TYPE
	CalendarObjectRef					= LocaleObjectRef;
	TimeObjectFormatString				= TextObject;
{  DateTimeFormat Types:  }
	FormatStringRef						= UInt32;

CONST
	kPreferredDateTimeFormat	= 0;
	kShortDateTimeFormat		= 1;
	kLongDateTimeFormat			= 2;
	kShortTimeFormat			= 3;
	kLongTimeFormat				= 4;

{$ENDC}
{
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 ++																				++
 ++						Type definitions for Legacy APIs						++
 ++																				++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_DEPRECATED }
{

	Here are the current routine names and the translations to the older forms.
	Please use the newer forms in all new code and migrate the older names out of existing
	code as maintainance permits.
	
	New Name					Old Name(s)
	
	DateString					IUDatePString IUDateString 
	InitDateCache
	LongDateString				IULDateString
	LongTimeString				IULTimeString
	StringToDate				String2Date
	StringToTime								
	TimeString					IUTimeString IUTimePString
}

CONST
	shortDate					= 0;
	longDate					= 1;
	abbrevDate					= 2;


TYPE
	DateForm							= SInt8;

CONST
																{  StringToDate status values  }
	fatalDateTime				= $8000;						{  StringToDate and String2Time mask to a fatal error  }
	longDateFound				= 1;							{  StringToDate mask to long date found  }
	leftOverChars				= 2;							{  StringToDate & Time mask to warn of left over characters  }
	sepNotIntlSep				= 4;							{  StringToDate & Time mask to warn of non-standard separators  }
	fieldOrderNotIntl			= 8;							{  StringToDate & Time mask to warn of non-standard field order  }
	extraneousStrings			= 16;							{  StringToDate & Time mask to warn of unparsable strings in text  }
	tooManySeps					= 32;							{  StringToDate & Time mask to warn of too many separators  }
	sepNotConsistent			= 64;							{  StringToDate & Time mask to warn of inconsistent separators  }
	tokenErr					= $8100;						{  StringToDate & Time mask for 'tokenizer err encountered'  }
	cantReadUtilities			= $8200;
	dateTimeNotFound			= $8400;
	dateTimeInvalid				= $8800;


TYPE
	StringToDateStatus					= INTEGER;
	String2DateStatus					= INTEGER;
	DateCacheRecordPtr = ^DateCacheRecord;
	DateCacheRecord = PACKED RECORD
		hidden:					ARRAY [0..255] OF INTEGER;				{  only for temporary use  }
	END;

	DateCachePtr						= ^DateCacheRecord;
{$ENDC}
{
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 ++																				++
 ++								Modern API Definitions							++
 ++																				++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
}
{$IFC FOR_SYSTEM8_PREEMPTIVE }
{
 *********************************************************
 *
 * TimeObject Constructors
 *
 *********************************************************
}
FUNCTION CreateTimeObject(timeObject: TimeObjectPtr; utcTime: ConstUTCTimeRecordPtr): OSStatus; C;
FUNCTION CreateTimeObjectInterval(timeObjectInterval: TimeObjectIntervalPtr; utcTimeInterval: ConstUTCTimeIntervalRecordPtr): OSStatus; C;
{
 *********************************************************
 *
 * Getter and Setter Functions for TimeObjects
 *
 *********************************************************
}
FUNCTION GetCurrentTime(timeObj: TimeObjectPtr): OSStatus; C;
FUNCTION SetCurrentTime(timeObj: ConstTimeObjectPtr): OSStatus; C;
{
 *********************************************************
 *
 * Getter and Setter Functions for Machine Location
 *
 *********************************************************
}
FUNCTION GetMachineLocation(machineLocation: MachineLocationRecordPtr): OSStatus; C;
FUNCTION SetMachineLocation(machineLocation: ConstMachineLocationRecordPtr): OSStatus; C;
{
 *********************************************************
 *
 * Getter and Setter Functions for TimeObjects Precision
 *
 *********************************************************
}
FUNCTION GetTimeObjectPrecision(timeObj: ConstTimeObjectPtr; VAR precision: TimeObjectPrecision): OSStatus; C;
FUNCTION SetTimeObjectPrecision(timeObj: TimeObjectPtr; precision: ByteParameter): OSStatus; C;
FUNCTION GetTimeObjectIntervalPrecision(timeObj: ConstTimeObjectIntervalPtr; VAR precision: TimeObjectPrecision): OSStatus; C;
FUNCTION SetTimeObjectIntervalPrecision(timeObj: TimeObjectIntervalPtr; precision: ByteParameter): OSStatus; C;
{
 *********************************************************
 *
 * Timers
 *
 *********************************************************
}
FUNCTION CreateTimeObjectNotifier(timeObject: ConstTimeObjectPtr; VAR notifier: KernelNotification; VAR notificationRef: TimeObjectNotificationRef): OSStatus; C;
FUNCTION CancelTimeObjectNotifier(notificationRef: TimeObjectNotificationRef): OSStatus; C;
{
 *********************************************************
 *
 * Manipulation and Comparison functions for TimeObjects
 *
 *********************************************************
}
FUNCTION AddToFixedTimeObject(fixedTimeObj: ConstTimeObjectPtr; offsetTimeObj: ConstTimeObjectIntervalPtr; result: TimeObjectPtr): OSStatus; C;
FUNCTION AddTimeObjectIntervals(timeObj1: ConstTimeObjectIntervalPtr; timeObj2: ConstTimeObjectIntervalPtr; result: TimeObjectIntervalPtr): OSStatus; C;
FUNCTION SubtractFromFixedTimeObject(fixedTimeObj: ConstTimeObjectPtr; offsetTimeObj: ConstTimeObjectIntervalPtr; result: TimeObjectPtr): OSStatus; C;
FUNCTION SubtractTimeObjectIntervals(timeObj1: ConstTimeObjectIntervalPtr; timeObj2: ConstTimeObjectIntervalPtr; result: TimeObjectIntervalPtr): OSStatus; C;
FUNCTION SubtractFixedTimeObjects(timeObj1: ConstTimeObjectPtr; timeObj2: ConstTimeObjectPtr; result: TimeObjectIntervalPtr): OSStatus; C;
FUNCTION CompareFixedTimeObjects(timeObj1: ConstTimeObjectPtr; timeObj2: ConstTimeObjectPtr; precision: ConstTimeObjectIntervalPtr; VAR result: SInt32): OSStatus; C;
FUNCTION CompareTimeObjectIntervals(timeObj1: ConstTimeObjectIntervalPtr; timeObj2: ConstTimeObjectIntervalPtr; precision: ConstTimeObjectIntervalPtr; VAR result: SInt32): OSStatus; C;
{
 *********************************************************
 *
 * TimeObjects to Seconds from 1/1/04 conversion functions
 *
 *********************************************************
}
FUNCTION ConvertSecondsToTimeObject(seconds: UInt32; convertedTimeObj: TimeObjectPtr): OSStatus; C;
FUNCTION ConvertTimeObjectToSeconds(timeObj: ConstTimeObjectPtr; VAR seconds: UInt32): OSStatus; C;
FUNCTION ConvertLongDateTimeToTimeObject(VAR longDateTime: LongDateTime; convertedTimeObj: TimeObjectPtr): OSStatus; C;
FUNCTION ConvertTimeObjectToLongDateTime(timeObj: ConstTimeObjectPtr; VAR longDateTime: LongDateTime): OSStatus; C;
{
 *********************************************************
 *
 * TimeObjectIntervals to Nanosecond conversion functions
 *
 *********************************************************
}
FUNCTION ConvertTimeObjectIntervalToNanoseconds(source: ConstTimeObjectIntervalPtr; VAR result: Nanoseconds): OSStatus; C;
FUNCTION ConvertNanosecondsToTimeObjectInterval(VAR source: Nanoseconds; result: TimeObjectIntervalPtr): OSStatus; C;
{
 *********************************************************
 *
 * Internet Time/Mail Conversion Routines
 *
 *********************************************************
}
FUNCTION ConvertTimeObjectToInternetMailTime(source: ConstTimeObjectPtr; result: TextObject): OSStatus; C;
FUNCTION ConvertInternetMailTimeToTimeObject(source: TextObject; result: TimeObjectPtr): OSStatus; C;
FUNCTION ConvertTimeObjectToInternetTime(source: ConstTimeObjectPtr; VAR result: UInt32): OSStatus; C;
FUNCTION ConvertInternetTimeToTimeObject(internetTime: UInt32; result: TimeObjectPtr): OSStatus; C;
{
 *********************************************************
 *
 * Calendar Routines
 *
 *********************************************************
}
FUNCTION GetDefaultCalendar(theLocale: LocaleRef; VAR theCalendar: CalendarObjectRef): OSStatus; C;
FUNCTION GetDefaultSystemCalendar(VAR theCalendar: CalendarObjectRef): OSStatus; C;
{
 *********************************************************
 *
 * Text Conversion Routines
 *
 *********************************************************
}
FUNCTION ConvertTimeObjectToDateString(timeObj: ConstTimeObjectPtr; theCalendar: CalendarObjectRef; textObj: TextObject; format: TimeObjectFormatString; formatSelector: FormatStringRef; conversionSelector: TimeObjectConversionType): OSStatus; C;
FUNCTION ConvertTimeObjectToTimeString(timeObjectInterval: ConstTimeObjectIntervalPtr; theCalendar: CalendarObjectRef; textObj: TextObject; format: TimeObjectFormatString; formatSelector: FormatStringRef; conversionSelector: TimeObjectConversionType): OSStatus; C;
FUNCTION ConvertDateStringToTimeObject(timeObj: TimeObjectPtr; theCalendar: CalendarObjectRef; textObj: TextObject; conversionSelector: TimeObjectConversionType): OSStatus; C;
FUNCTION ConvertTimeStringToTimeObject(timeObjectInterval: TimeObjectIntervalPtr; theCalendar: CalendarObjectRef; textObj: TextObject; conversionSelector: TimeObjectConversionType): OSStatus; C;
{$ENDC}
{
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 ++																				++
 ++								Legacy API Definitions							++
 ++																				++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
 +++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_DEPRECATED }
{
 **************************************************************************************
 *
 * The following functions are new names that work on 68k and PowerPC
 *
 **************************************************************************************
}
FUNCTION InitDateCache(theCache: DateCachePtr): OSErr;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8204, $FFF8, $A8B5;
	{$ENDC}
FUNCTION StringToDate(textPtr: Ptr; textLen: LONGINT; theCache: DateCachePtr; VAR lengthUsed: LONGINT; VAR dateTime: LongDateRec): StringToDateStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8214, $FFF6, $A8B5;
	{$ENDC}
FUNCTION StringToTime(textPtr: Ptr; textLen: LONGINT; theCache: DateCachePtr; VAR lengthUsed: LONGINT; VAR dateTime: LongDateRec): StringToDateStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $2F3C, $8214, $FFF4, $A8B5;
	{$ENDC}
PROCEDURE IUDateString(dateTime: LONGINT; longFlag: DateForm; VAR result: Str255);
	{$IFC NOT GENERATINGCFM}
	INLINE $4267, $A9ED;
	{$ENDC}
PROCEDURE IUTimeString(dateTime: LONGINT; wantSeconds: BOOLEAN; VAR result: Str255);
	{$IFC NOT GENERATINGCFM}
	INLINE $3F3C, $0002, $A9ED;
	{$ENDC}
PROCEDURE IUDatePString(dateTime: LONGINT; longFlag: DateForm; VAR result: Str255; intlHandle: Handle);
	{$IFC NOT GENERATINGCFM}
	INLINE $3F3C, $000E, $A9ED;
	{$ENDC}
PROCEDURE IUTimePString(dateTime: LONGINT; wantSeconds: BOOLEAN; VAR result: Str255; intlHandle: Handle);
	{$IFC NOT GENERATINGCFM}
	INLINE $3F3C, $0010, $A9ED;
	{$ENDC}
PROCEDURE IULDateString(VAR dateTime: LongDateTime; longFlag: DateForm; VAR result: Str255; intlHandle: Handle);
	{$IFC NOT GENERATINGCFM}
	INLINE $3F3C, $0014, $A9ED;
	{$ENDC}
PROCEDURE IULTimeString(VAR dateTime: LongDateTime; wantSeconds: BOOLEAN; VAR result: Str255; intlHandle: Handle);
	{$IFC NOT GENERATINGCFM}
	INLINE $3F3C, $0016, $A9ED;
	{$ENDC}
{
 **************************************************************************************
 *
 * The following provide direct function prototypes for new names for 68k
 *
 **************************************************************************************
}
PROCEDURE DateString(dateTime: LONGINT; longFlag: DateForm; VAR result: Str255; intlHandle: Handle);
	{$IFC NOT GENERATINGCFM}
	INLINE $3F3C, $000E, $A9ED;
	{$ENDC}
PROCEDURE TimeString(dateTime: LONGINT; wantSeconds: BOOLEAN; VAR result: Str255; intlHandle: Handle);
	{$IFC NOT GENERATINGCFM}
	INLINE $3F3C, $0010, $A9ED;
	{$ENDC}
PROCEDURE LongDateString(VAR dateTime: LongDateTime; longFlag: DateForm; VAR result: Str255; intlHandle: Handle);
	{$IFC NOT GENERATINGCFM}
	INLINE $3F3C, $0014, $A9ED;
	{$ENDC}
PROCEDURE LongTimeString(VAR dateTime: LongDateTime; wantSeconds: BOOLEAN; VAR result: Str255; intlHandle: Handle);
	{$IFC NOT GENERATINGCFM}
	INLINE $3F3C, $0016, $A9ED;
	{$ENDC}
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := TimeObjectsIncludes}

{$ENDC} {__TIMEOBJECTS__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
