{
 	File:		Timing.p
 
 	Contains:	Kernel Timing Interfaces.
 
 	Version:	Technology:	System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT Timing;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __TIMING__}
{$SETC __TIMING__ := 1}

{$I+}
{$SETC TimingIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}

{$PUSH}
{$ALIGN POWER}
{$LibExport+}

{$IFC FOR_SYSTEM8_PREEMPTIVE }

CONST
	kDurationMicrosecond		= -1;							{  Microseconds are negative  }
	kDurationMillisecond		= 1;							{  Milliseconds are positive }
	kDurationSecond				= 1000;							{  1000 * durationMillisecond }
	kDurationMinute				= 60000;						{  60 * durationSecond, }
	kDurationHour				= 3600000;						{  60 * durationMinute, }
	kDurationDay				= 86400000;						{  24 * durationHour, }
	kDurationNoWait				= 0;							{  don't block }
	kDurationForever			= $7FFFFFFF;					{  no time limit }

{$IFC OLDROUTINENAMES }
	durationMicrosecond			= -1;
	durationMillisecond			= 1;
	durationSecond				= 1000;
	durationMinute				= 60000;
	durationHour				= 3600000;
	durationDay					= 86400000;
	durationNoWait				= 0;
	durationForever				= $7FFFFFFF;

{$ENDC}

TYPE
	Nanoseconds							= UInt64;
	NanosecondsPtr 						= ^Nanoseconds;
	Ticks								= UInt32;
{
	Time Information Routines
}
FUNCTION UpTime: AbsoluteTime; C;
FUNCTION TaskCPUTime: AbsoluteTime; C;
PROCEDURE GetTimeBaseInfo(VAR theMinAbsoluteTimeDelta: UInt32; VAR theAbsoluteTimeToNanosecondNumerator: UInt32; VAR theAbsoluteTimeToNanosecondDenominator: UInt32; VAR theProcessorToAbsoluteTimeNumerator: UInt32; VAR theProcessorToAbsoluteTimeDenominator: UInt32); C;
{
	Timing Conversion Routines
}
FUNCTION AbsoluteToNanoseconds(theAbsoluteTime: AbsoluteTime): Nanoseconds; C;
FUNCTION AbsoluteToDuration(theAbsoluteTime: AbsoluteTime): Duration; C;
FUNCTION NanosecondsToAbsolute(theNanoseconds: Nanoseconds): AbsoluteTime; C;
FUNCTION DurationToAbsolute(theDuration: Duration): AbsoluteTime; C;
FUNCTION DurationToNanoseconds(theDuration: Duration): Nanoseconds; C;
FUNCTION NanosecondsToDuration(theNanoseconds: Nanoseconds): Duration; C;
FUNCTION AbsoluteToTicks(theAbsoluteTime: AbsoluteTime): Ticks; C;
FUNCTION TicksToAbsolute(theTicks: Ticks): AbsoluteTime; C;
{
	AbsoluteTime Adjustment Routines
}
FUNCTION AddAbsoluteToAbsolute(theAbsoluteTime1: AbsoluteTime; theAbsoluteTime2: AbsoluteTime): AbsoluteTime; C;
FUNCTION SubAbsoluteFromAbsolute(theLeftAbsoluteTime: AbsoluteTime; theRightAbsoluteTime: AbsoluteTime): AbsoluteTime; C;
FUNCTION AddNanosecondsToAbsolute(theNanoseconds: Nanoseconds; theAbsoluteTime: AbsoluteTime): AbsoluteTime; C;
FUNCTION AddDurationToAbsolute(theDuration: Duration; theAbsoluteTime: AbsoluteTime): AbsoluteTime; C;
FUNCTION SubNanosecondsFromAbsolute(theNanoseconds: Nanoseconds; theAbsoluteTime: AbsoluteTime): AbsoluteTime; C;
FUNCTION SubDurationFromAbsolute(theDuration: Duration; theAbsoluteTime: AbsoluteTime): AbsoluteTime; C;
{
	Timing Delta Routines
}
FUNCTION AbsoluteDeltaToNanoseconds(theLeftAbsoluteTime: AbsoluteTime; theRightAbsoluteTime: AbsoluteTime): Nanoseconds; C;
FUNCTION AbsoluteDeltaToDuration(theLeftAbsoluteTime: AbsoluteTime; theRightAbsoluteTime: AbsoluteTime): Duration; C;
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := TimingIncludes}

{$ENDC} {__TIMING__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
