{
 	File:		Types.p
 
 	Contains:	Basic Macintosh data types.
 
 	Version:	Technology:	System 7.5
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT Types;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __TYPES__}
{$SETC __TYPES__ := 1}

{$I+}
{$SETC TypesIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __CONDITIONALMACROS__}
{$I ConditionalMacros.p}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}


CONST
	noErr						= 0;


TYPE
	Byte								= 0..255;
	SignedByte							= -128..127;
	UInt8								= Byte;
	SInt8								= SignedByte;
	UInt16								= INTEGER;
	SInt16								= INTEGER;
	UInt32								= LONGINT;
	SInt32								= LONGINT;
	UniChar								= UInt16;
	ByteParameter = SignedByte;

	Ptr									= ^SignedByte;
{   pointer to a master pointer  }
	Handle								= ^Ptr;
{$IFC UNDEFINED qMacApp }
	IntegerPtr							= ^INTEGER;
	LongIntPtr							= ^LONGINT;
{$ENDC}
{  fixed point arithmatic type  }
	Fixed								= LONGINT;
	FixedPtr							= ^Fixed;
	Fract								= LONGINT;
	FractPtr							= ^Fract;
{
Note: on PowerPC extended is undefined.
      on 68K when mc68881 is on, extended is 96 bits.  
             when mc68881 is off, extended is 80 bits.  
      Some old toolbox routines require an 80 bit extended so we define extended80
}
TYPE
{$IFC GENERATING68K AND GENERATING68881 }
	extended96 = Extended;
{$ELSEC}
	extended96 = RECORD
		exp:					ARRAY [0..1] OF INTEGER;
		man:					ARRAY [0..3] OF INTEGER;
	END;
{$ENDC}
{$IFC GENERATING68K AND NOT GENERATING68881 }
	extended80 = Extended;
{$ELSEC}
	extended80 = RECORD
		exp:					INTEGER;
		man:					ARRAY [0..3] OF INTEGER;
	END;
{$ENDC}
{
Note: float_t and double_t are "natural" computational types
      (i.e.the compiler/processor can most easily do floating point
	  operations with that type.) 
}
{$IFC GENERATINGPOWERPC }
{  on PowerPC, double = 64-bit which is fastest.  float = 32-bit  }
	float_t								= Single;
	double_t							= Double;
{$IFC LSPWRP }
	LongDouble = RECORD
		head:					Double;
		tail:					Double;
	END;
{$ENDC}
{$ELSEC}
{  on 68K, long double (a.k.a. extended) is always the fastest.  It is 80 or 96-bits  }
	float_t								= extended;
	double_t							= extended;
{$ENDC}
	SInt64Ptr = ^SInt64;
	SInt64 = RECORD
		hi:						SInt32;
		lo:						UInt32;
	END;

	UInt64Ptr = ^UInt64;
	UInt64 = RECORD
		hi:						UInt32;
		lo:						UInt32;
	END;

{
	wide and UnsignedWide are being replace by SInt64 and UInt64 in the Math64 library and interfaces
}
	wide								= SInt64;
	widePtr 							= ^wide;
	UnsignedWide						= UInt64;
	UnsignedWidePtr 					= ^UnsignedWide;

CONST
	v							= 0;
	h							= 1;


TYPE
	VHSelect							= SInt8;
	ProcPtr = Ptr;
	Register68kProcPtr = ProcPtr;
	ProcHandle							= ^ProcPtr;
{  UniversalProcPtr is ^RoutineDescriptor on a PowerPC machine  }
	UniversalProcPtr					= ProcPtr;
	UniversalProcHandle					= ^ProcPtr;
	Str255								= STRING[255];
	Str63								= STRING[63];
	Str32								= STRING[32];
	Str31								= STRING[31];
	Str27								= STRING[27];
	Str15								= STRING[15];
{
	The type Str32 is used in many AppleTalk based data structures.
	It holds up to 32 one byte chars.  The problem is that with the
	length byte it is 33 bytes long.  This can cause weird alignment
	problems in structures.  To fix this the type "Str32Field" has
	been created.  It should only be used to hold 32 chars, but
	it is 34 bytes long so that there are no alignment problems.
}
	Str32Field = Str32;
	StringPtr							= ^Str255;
	StringHandle						= ^StringPtr;
{
 A C string is a zero terminated array of bytes.  There is no length byte.
    a CStringPtr is a pointer to a C string (e.g. char* )
    a ConstCStringPtr is a CStringPtr whose contents cannot be changed (e.g. const char* )
}
	CStringPtr							= Ptr;
	ConstCStringPtr						= Ptr;
	ConstStr255Param					= Str255;
	ConstStr63Param						= Str63;
	ConstStr32Param						= Str32;
	ConstStr31Param						= Str31;
	ConstStr27Param						= Str27;
	ConstStr15Param						= Str15;
{  error code  }
	OSErr								= INTEGER;
	ScriptCode							= INTEGER;
	LangCode							= INTEGER;
	RegionCode							= INTEGER;
{$IFC GENERATING68K OR UNDEFINED MWERKS }
	FourCharCode =  PACKED ARRAY [1..4] OF CHAR;
{$ELSEC}
	FourCharCode =  UNSIGNEDLONG;
{$ENDC}
	CharParameter = CHAR;

	StyleItem = (bold,italic,underline,outline,shadow,condense,extend);
	Style = SET OF StyleItem;

	StyleParameter = Style;

	StyleField = Style;
{
	CharParameter is only used in function parameter lists.  
	StyleParameter is only used in function parameter lists.
	StyleField is only used in struct fields.  
	The original Macintosh toolbox in 68K pascal defined Style as a SET.  
	Both Style and CHAR can occupy 8-bits in packed records or 16-bits when used as fields
	in non-packed records or as parameters. 
	These intermediate types hide that difference.
}
	OSType								= FourCharCode;
	ResType								= FourCharCode;
	OSTypePtr							= ^OSType;
	ResTypePtr							= ^ResType;
	PointPtr = ^Point;
	Point = RECORD
		CASE INTEGER OF
		0: (
			v:					INTEGER;
			h:					INTEGER;
		   );
		1: (
			vh:					ARRAY [0..1] OF INTEGER;
			);
	END;

	RectPtr = ^Rect;
	Rect = RECORD
		CASE INTEGER OF
		0: (
			top:				INTEGER;
			left:				INTEGER;
			bottom:				INTEGER;
			right:				INTEGER;
		   );
		1: (
			topLeft:			Point;
			botRight:			Point;
		   );
	END;

{
	kVariableLengthArray is used in array bounds to specify a variable length array.
	It is ususally used in variable length structs when the last field is an array
	of any size.  Before ANSI C, we used zero as the bounds of variable length 
	array, but that is illegal in ANSI C.  Example:
	
		struct FooList 
		(
			short 	listLength;
			Foo		elements[kVariableLengthArray];
		);
}

CONST
	kVariableLengthArray		= 1;

{  Numeric version part of 'vers' resource  }

TYPE
	NumVersionPtr = ^NumVersion;
	NumVersion = PACKED RECORD
		majorRev:				UInt8;									{ 1st part of version number in BCD }
		minorAndBugRev:			UInt8;									{ 2nd & 3rd part of version number share a byte }
		stage:					UInt8;									{ stage code: dev, alpha, beta, final }
		nonRelRev:				UInt8;									{ revision level of non-released version }
	END;

{  Version Release Stage Codes  }

CONST
	developStage				= $20;
	alphaStage					= $40;
	betaStage					= $60;
	finalStage					= $80;

{  Wrapper so NumVersion can be accessed as a 32-bit value  }

TYPE
	NumVersionVariantPtr = ^NumVersionVariant;
	NumVersionVariant = RECORD
		CASE INTEGER OF
		0: (
			parts:				NumVersion;
			);
		1: (
			whole:				LONGINT;
			);
	END;

{  'vers' resource format  }
	VersRecPtr = ^VersRec;
	VersRec = RECORD
		numericVersion:			NumVersion;								{ encoded version number }
		countryCode:			INTEGER;								{ country code from intl utilities }
		shortVersion:			Str255;									{ version number string - worst case }
		reserved:				Str255;									{ longMessage string packed after shortVersion }
	END;

	VersRecHndl							= ^VersRecPtr;
	OSStatus							= SInt32;
	LogicalAddress						= Ptr;
	ConstLogicalAddress					= Ptr;
	BytePtr								= ^UInt8;
	ByteCount							= UInt32;
	ByteOffset							= UInt32;
	ItemCount							= UInt32;
	PhysicalAddress						= Ptr;
	OptionBits							= UInt32;
	PBVersion							= UInt32;
	Duration							= SInt32;
	AbsoluteTime						= UInt64;
	AbsoluteTimePtr 					= ^AbsoluteTime;

CONST
	kSizeOfTimeObject			= 16;

{  TimeObject type definitions  }

TYPE
	TimeObjectPtr = ^TimeObject;
	TimeObject = RECORD
		hidden:					PACKED ARRAY [0..15] OF UInt8;
	END;

	ConstTimeObjectPtr					= ^TimeObject;
	TimeObjectIntervalPtr = ^TimeObjectInterval;
	TimeObjectInterval = RECORD
		hidden:					PACKED ARRAY [0..15] OF UInt8;
	END;

	ConstTimeObjectIntervalPtr			= ^TimeObjectInterval;
{$IFC FOR_SYSTEM8_COOPERATIVE }
{
	RefLabels: these are non-localizable identifiers for system objects. These should
	be passed by reference.  
}
	RefLabelPtr = ^RefLabel;
	RefLabel = RECORD
		creator:				OSType;									{  creator of the object.  should be the same as the application signature. }
		id:						OSType;									{  uniquely identifies the object within a scope defined by semantics of the object }
	END;

{$ENDC}

CONST
	kInvalidID					= 0;

	kNilOptions					= 0;

{
	Who implements what debugger functions:
	
	Name			MacsBug			Macintosh Debugger					Copland Debugger
	----------		-----------		-----------------------------		-------------------
	Debugger		yes				InterfaceLib maps to DebugStr		yes
	DebugStr		yes				yes									yes
	Debugger68k		yes				InterfaceLib maps to DebugStr		obsolete?
	DebugStr68k		yes				InterfaceLib maps to DebugStr		obsolete?
	debugstr		yes				InterfaceLib maps to DebugStr		yes
	SysBreak		no				InterfaceLib maps to SysError		obsolete?
	SysBreakStr		no				InterfaceLib maps to SysError		obsolete?
	SysBreakFunc	no				InterfaceLib maps to SysError		obsolete?
	SysDebug		?				?									?
	SysDebugStr		?				?									?
	LLDebugger		no				yes									Low Level Nub
	LLDebugStr		no				yes									Low Level Nub
}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_PREEMPTIVE }
PROCEDURE Debugger;
	{$IFC NOT GENERATINGCFM}
	INLINE $A9FF;
	{$ENDC}
PROCEDURE DebugStr(debuggerMsg: Str255);
	{$IFC NOT GENERATINGCFM}
	INLINE $ABFF;
	{$ENDC}
{$ENDC}
{$IFC FOR_SYSTEM8_PREEMPTIVE }
{  Low level Copland debugger  }
PROCEDURE LLDebugger;
PROCEDURE LLDebugStr(debuggerMsg: Str255);
{$ENDC}
{$IFC FOR_SYSTEM7_ONLY }
{  Only for System 7 native drivers  }
PROCEDURE SysDebug; C;
PROCEDURE SysDebugStr(str: Str255); C;
{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_DEPRECATED }
{  SADE break points  }
PROCEDURE SysBreak;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $FE16, $A9C9;
	{$ENDC}
PROCEDURE SysBreakStr(debuggerMsg: Str255);
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $FE15, $A9C9;
	{$ENDC}
PROCEDURE SysBreakFunc(debuggerMsg: Str255);
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $FE14, $A9C9;
	{$ENDC}
{$ENDC}
{$IFC FOR_SYSTEM7_ONLY }
{  old names for Debugger and DebugStr  }
PROCEDURE Debugger68k;
	{$IFC NOT GENERATINGCFM}
	INLINE $A9FF;
	{$ENDC}
PROCEDURE DebugStr68k(debuggerMsg: Str255);
	{$IFC NOT GENERATINGCFM}
	INLINE $ABFF;
	{$ENDC}
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := TypesIncludes}

{$ENDC} {__TYPES__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
