{
 	File:		Unicode.p
 
 	Contains:	Unicode Interfaces.
 
 	Version:	Technology:	System 7.1 through System 8
 				Release:	Universal Interfaces 3.0d3 on Copland DR1
 
 	Copyright:	 1984-1996 by Apple Computer, Inc.  All rights reserved.
 
 	Bugs?:		If you find a problem with this file, send the file and version
 				information (from above) and the problem description to:
 
 					Internet:	apple.bugs@applelink.apple.com
 					AppleLink:	APPLE.BUGS
 
}
{$IFC UNDEFINED UsingIncludes}
{$SETC UsingIncludes := 0}
{$ENDC}

{$IFC NOT UsingIncludes}
 UNIT Unicode;
 INTERFACE
{$ENDC}

{$IFC UNDEFINED __UNICODE__}
{$SETC __UNICODE__ := 1}

{$I+}
{$SETC UnicodeIncludes := UsingIncludes}
{$SETC UsingIncludes := 1}

{$IFC UNDEFINED __TYPES__}
{$I Types.p}
{$ENDC}
{$IFC UNDEFINED __TEXTCOMMON__}
{$I TextCommon.p}
{$ENDC}
{$IFC UNDEFINED __MIXEDMODE__}
{$I MixedMode.p}
{$ENDC}

{$PUSH}
{$ALIGN MAC68K}
{$LibExport+}

{$IFC 0 }
{
 The following 7 typedefs are required for seeds until they get
 moved to a future version of Types.[hp] in a future ETO release.
 Also note that seeds should include a copy of the new TextCommon.[hp].
}

TYPE
	BytePtr								= ^UInt8;
	ByteCount							= UInt32;
	ItemCount							= UInt32;
	OptionBits							= UInt32;
	RegionCode							= INTEGER;
	ByteOffset							= UInt32;
	ConstLogicalAddress					= LogicalAddress;
{
 The following typedefs are required for seeds until they get
 moved to a future version of Errors.[hp] in a future ETO release.
 Unicode Converter Error Codes
}

CONST
	unicodeChecksumErr			= -8769;
	unicodeNoTableErr			= -8768;
	unicodeVariantErr			= -8767;
	unicodeFallbacksErr			= -8766;
	unicodePartConvertErr		= -8765;
	unicodeBufErr				= -8764;
	unicodeCharErr				= -8763;
	unicodeElementErr			= -8762;
	unicodeNotFoundErr			= -8761;
	unicodeTableFormatErr		= -8760;
	unicodeDirectionErr			= -8759;
	unicodeContextualErr		= -8758;
	unicodeTextEncodingDataErr	= -8757;

{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_PREEMPTIVE }
{  Unicode Converter Gestalt Constants: (these belong in Gestalt.i)  }

CONST
	gestaltUnicodeAttr			= 'unic';
	gestaltUnicodeConverterPresent = 0;
	gestaltUnicodeConverterMask	= $00000001;

{  Basic types for Unicode characters and strings:  }

TYPE
	UniCharArrayPtr						= ^UniChar;
	ConstUniCharArrayPtr				= ^UniChar;
{  Unicode conversion contexts:  }
	TextToUnicodeInfo = ^LONGINT;
	UnicodeToTextInfo = ^LONGINT;
	UnicodeToTextRunInfo = ^LONGINT;
	ConstTextToUnicodeInfo				= TextToUnicodeInfo;
	ConstUnicodeToTextInfo				= UnicodeToTextInfo;
{  UnicodeMapVersion type & values  }
	UnicodeMapVersion					= SInt32;

CONST
	kUnicodeUseLatestMapping	= -1;

{  Types used in conversion  }

TYPE
	UnicodeMappingPtr = ^UnicodeMapping;
	UnicodeMapping = RECORD
		unicodeEncoding:		TextEncoding;
		otherEncoding:			TextEncoding;
		mappingVersion:			UnicodeMapVersion;
	END;

	ConstUnicodeMappingPtr				= ^UnicodeMapping;
	TextEncodingRunPtr = ^TextEncodingRun;
	TextEncodingRun = RECORD
		offset:					ByteOffset;
		textEncoding:			TextEncoding;
	END;

{  Control flags for ConvertUnicodeToText and ConvertTextToUnicode  }

CONST
	kUnicodeUseFallbacksBit		= 0;
	kUnicodeKeepInfoBit			= 1;
	kUnicodeDirectionalityBits	= 2;
	kUnicodeVerticalFormBit		= 4;
	kUnicodeLooseMappingsBit	= 5;
	kUnicodeStringUnterminatedBit = 6;
	kUnicodeTextRunBit			= 7;
	kUnicodeKeepSameEncodingBit	= 8;

	kUnicodeUseFallbacksMask	= $00000001;
	kUnicodeKeepInfoMask		= $00000002;
	kUnicodeDirectionalityMask	= $0000000C;
	kUnicodeVerticalFormMask	= $00000010;
	kUnicodeLooseMappingsMask	= $00000020;
	kUnicodeStringUnterminatedMask = $00000040;
	kUnicodeTextRunMask			= $00000080;
	kUnicodeKeepSameEncodingMask = $00000100;

{  Values for kUnicodeDirectionality field  }
	kUnicodeDefaultDirection	= 0;
	kUnicodeLeftToRight			= 1;
	kUnicodeRightToLeft			= 2;

{  Control flags for TruncateForUnicodeToText:  }
	kUnicodeTextElementSafeBit	= 0;
	kUnicodeRestartSafeBit		= 1;

	kUnicodeTextElementSafeMask	= $00000001;
	kUnicodeRestartSafeMask		= $00000002;

{  Filter bits for QueryUnicodeMappings filter field:  }
	kUnicodeMatchUnicodeBaseBit	= 0;
	kUnicodeMatchUnicodeVariantBit = 1;
	kUnicodeMatchUnicodeFormatBit = 2;
	kUnicodeMatchOtherBaseBit	= 3;
	kUnicodeMatchOtherVariantBit = 4;
	kUnicodeMatchOtherFormatBit	= 5;

	kUnicodeMatchUnicodeBaseMask = $00000001;
	kUnicodeMatchUnicodeVariantMask = $00000002;
	kUnicodeMatchUnicodeFormatMask = $00000004;
	kUnicodeMatchOtherBaseMask	= $00000008;
	kUnicodeMatchOtherVariantMask = $00000010;
	kUnicodeMatchOtherFormatMask = $00000020;

{  Control flags for SetFallbackUnicodeToText  }
	kUnicodeFallbackSequencingBits = 0;

	kUnicodeFallbackSequencingMask = $00000003;

{  values for kUnicodeFallbackSequencing field  }
	kUnicodeFallbackDefaultOnly	= 0;
	kUnicodeFallbackCustomOnly	= 1;
	kUnicodeFallbackDefaultFirst = 2;
	kUnicodeFallbackCustomFirst	= 3;

{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_COOPERATIVE }
{  Caller-supplied entry point to a fallback handler  }

TYPE
	UnicodeToTextFallbackProcPtr = ProcPtr;  { FUNCTION UnicodeToTextFallback(VAR srcUniStr: UniChar; srcUniStrLen: ByteCount; VAR srcConvLen: ByteCount; destStr: BytePtr; destStrLen: ByteCount; VAR destConvLen: ByteCount; contextPtr: LogicalAddress; unicodeMappingPtr: ConstUnicodeMappingPtr): OSStatus; }

	UnicodeToTextFallbackUPP = UniversalProcPtr;

CONST
	uppUnicodeToTextFallbackProcInfo = $003FFFF0;

FUNCTION NewUnicodeToTextFallbackProc(userRoutine: UnicodeToTextFallbackProcPtr): UnicodeToTextFallbackUPP;
	{$IFC NOT GENERATINGCFM }
	INLINE $2E9F;
	{$ENDC}

FUNCTION CallUnicodeToTextFallbackProc(VAR srcUniStr: UniChar; srcUniStrLen: ByteCount; VAR srcConvLen: ByteCount; destStr: BytePtr; destStrLen: ByteCount; VAR destConvLen: ByteCount; contextPtr: LogicalAddress; unicodeMappingPtr: ConstUnicodeMappingPtr; userRoutine: UnicodeToTextFallbackUPP): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $205F, $4E90;
	{$ENDC}
{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_PREEMPTIVE }

TYPE
	UnicodeToTextFallbackPreemptiveProcPtr = ProcPtr;  { FUNCTION UnicodeToTextFallbackPreemptive(VAR srcUniStr: UniChar; srcUniStrLen: ByteCount; VAR srcConvLen: ByteCount; destStr: BytePtr; destStrLen: ByteCount; VAR destConvLen: ByteCount; contextPtr: LogicalAddress; unicodeMappingPtr: ConstUnicodeMappingPtr): OSStatus; }

{  Function prototypes  }
{
 The following are in TextCommon.i:
 CreateTextEncoding, GetTextEncodingBase, GetTextEncodingVariant, GetTextEncodingFormat
}
{  Create a new TextToUnicodeInfo structure.  }
FUNCTION CreateTextToUnicodeInfo(UnicodeMapping: ConstUnicodeMappingPtr; VAR textToUnicodeInfo: TextToUnicodeInfo): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0401, $ABCE;
	{$ENDC}
{  Create a new UnicodeToTextInfo structure.  }
FUNCTION CreateUnicodeToTextInfo(UnicodeMapping: ConstUnicodeMappingPtr; VAR unicodeToTextInfo: UnicodeToTextInfo): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $040C, $ABCE;
	{$ENDC}
FUNCTION CreateUnicodeToTextRunInfo(numberOfMappings: ItemCount; UnicodeMapping: ConstUnicodeMappingPtr; VAR unicodeToTextInfo: UnicodeToTextRunInfo): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0612, $ABCE;
	{$ENDC}
{  Dispose of a TextToUnicodeInfo structure.  }
FUNCTION DisposeTextToUnicodeInfo(VAR textToUnicodeInfo: TextToUnicodeInfo): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0202, $ABCE;
	{$ENDC}
{  Dispose of a UnicodeToTextInfo structure.  }
FUNCTION DisposeUnicodeToTextInfo(VAR unicodeToTextInfo: UnicodeToTextInfo): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $020D, $ABCE;
	{$ENDC}
FUNCTION DisposeUnicodeToTextRunInfo(VAR unicodeToTextInfo: UnicodeToTextRunInfo): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0213, $ABCE;
	{$ENDC}
{  Convert a string to Unicode.  }
FUNCTION ConvertTextToUnicode(textToUnicodeInfo: TextToUnicodeInfo; sourceLen: ByteCount; sourceStr: ConstLogicalAddress; controlFlags: OptionBits; offsetCount: ItemCount; VAR offsetArray: ByteOffset; bufLen: ByteCount; VAR sourceRead: ByteCount; VAR unicodeLen: ByteCount; unicodeStr: UniCharArrayPtr): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $1404, $ABCE;
	{$ENDC}
{  Convert a string from Unicode.  }
FUNCTION ConvertUnicodeToText(unicodeToTextInfo: UnicodeToTextInfo; unicodeLen: ByteCount; unicodeStr: ConstUniCharArrayPtr; controlFlags: OptionBits; offsetCount: ItemCount; VAR offsetArray: ByteOffset; bufLen: ByteCount; VAR inputRead: ByteCount; VAR outputLen: ByteCount; outputStr: LogicalAddress): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $1403, $ABCE;
	{$ENDC}
FUNCTION ConvertUnicodeToTextRun(unicodeToTextInfo: UnicodeToTextRunInfo; unicodeLen: ByteCount; unicodeStr: ConstUniCharArrayPtr; controlFlags: OptionBits; offsetCount: ItemCount; VAR offsetArray: ByteOffset; bufLen: ByteCount; VAR inputRead: ByteCount; VAR outputLen: ByteCount; outputStr: LogicalAddress; encodingRunBufLen: ItemCount; VAR encodingRunOutLen: ItemCount; VAR encodingRuns: TextEncodingRun): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $1A14, $ABCE;
	{$ENDC}
{  Truncate a multibyte string at a safe place.  }
FUNCTION TruncateForTextToUnicode(textToUnicodeInfo: ConstTextToUnicodeInfo; sourceLen: ByteCount; sourceStr: ConstLogicalAddress; maxLen: ByteCount; VAR truncatedLen: ByteCount): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0A06, $ABCE;
	{$ENDC}
{  Truncate a Unicode string at a safe place.  }
FUNCTION TruncateForUnicodeToText(unicodeToTextInfo: ConstUnicodeToTextInfo; sourceLen: ByteCount; sourceStr: ConstUniCharArrayPtr; controlFlags: OptionBits; maxLen: ByteCount; VAR truncatedLen: ByteCount): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0C05, $ABCE;
	{$ENDC}
{  Convert a Pascal string to Unicode.  }
FUNCTION ConvertPStringToUnicode(textToUnicodeInfo: TextToUnicodeInfo; pascalStr: Str255; bufLen: ByteCount; VAR unicodeLen: ByteCount; unicodeStr: UniCharArrayPtr): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0A08, $ABCE;
	{$ENDC}
{  Convert a Unicode string to Pascal.  }
FUNCTION ConvertUnicodeToPString(unicodeToTextInfo: UnicodeToTextInfo; unicodeLen: ByteCount; unicodeStr: ConstUniCharArrayPtr; VAR pascalStr: Str255): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0807, $ABCE;
	{$ENDC}
{  Get a list of the available conversion mappings.  }
FUNCTION QueryUnicodeMappings(filter: OptionBits; findMapping: ConstUnicodeMappingPtr; maxCount: ItemCount; VAR actualCount: ItemCount; returnedMappings: UnicodeMappingPtr): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0A09, $ABCE;
	{$ENDC}
{  Get the name of a TextEncodingBase table.  }
FUNCTION GetTextEncodingBaseName(UnicodeMapping: ConstUnicodeMappingPtr; languageID: LangCode; bufLen: ByteCount; VAR nameLength: ByteCount; mappingName: UniCharArrayPtr): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $090A, $ABCE;
	{$ENDC}
{  Change the TextToUnicodeInfo to another mapping.  }
FUNCTION ChangeTextToUnicodeInfo(textToUnicodeInfo: TextToUnicodeInfo; UnicodeMapping: ConstUnicodeMappingPtr): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $040B, $ABCE;
	{$ENDC}
{  Change the UnicodeToTextInfo to another mapping.  }
FUNCTION ChangeUnicodeToTextInfo(unicodeToTextInfo: UnicodeToTextInfo; UnicodeMapping: ConstUnicodeMappingPtr): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $040E, $ABCE;
	{$ENDC}
{$ENDC}
{$IFC FOR_SYSTEM8_PREEMPTIVE }
{  Setup the fallback handler for converting Unicode To Text.  }
FUNCTION SetFallbackUnicodeToTextPreemptive(unicodeToTextInfo: UnicodeToTextInfo; fallback: UnicodeToTextFallbackPreemptiveProcPtr; controlFlags: OptionBits; infoPtr: LogicalAddress): OSStatus;
FUNCTION SetFallbackUnicodeToTextRunPreemptive(unicodeToTextRunInfo: UnicodeToTextRunInfo; fallback: UnicodeToTextFallbackPreemptiveProcPtr; controlFlags: OptionBits; infoPtr: LogicalAddress): OSStatus;
{$ENDC}
{$IFC FOR_SYSTEM7_AND_SYSTEM8_COOPERATIVE }
{  Setup the fallback handler for converting Unicode To Text.  }
FUNCTION SetFallbackUnicodeToText(unicodeToTextInfo: UnicodeToTextInfo; fallback: UnicodeToTextFallbackUPP; controlFlags: OptionBits; infoPtr: LogicalAddress): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $080F, $ABCE;
	{$ENDC}
FUNCTION SetFallbackUnicodeToTextRun(unicodeToTextRunInfo: UnicodeToTextRunInfo; fallback: UnicodeToTextFallbackUPP; controlFlags: OptionBits; infoPtr: LogicalAddress): OSStatus;
	{$IFC NOT GENERATINGCFM}
	INLINE $303C, $0819, $ABCE;
	{$ENDC}
{
 The following are in TextCommon.i:
 UpgradeScriptInfoToTextEncoding, RevertTextEncodingToScriptInfo
}
{$ENDC}
{$ALIGN RESET}
{$POP}

{$SETC UsingIncludes := UnicodeIncludes}

{$ENDC} {__UNICODE__}

{$IFC NOT UsingIncludes}
 END.
{$ENDC}
